//////////////////////////////////////////////////////////////////////////
/**

  luawinapi - winapi wrapper for Lua
  Copyright (C) 2011 Klaus Oberhofer. See copyright notice in
  LICENSE file
  
  !!! This file is generated by gen-w32api.lua  !!!

*/////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <commctrl.h>

#ifdef USE_AYGSHELL
#include <aygshell.h>
#endif

#ifdef UNDER_CE
#include <pm.h>
#include <connmgr.h>
#endif

#include <commdlg.h>

#include "gdihelpers.h"

#include "gen_structs.h"
#include "gen_abstractions.h"

// array type descriptors
static struct luacwrap_ArrayType regType_UINT8_32 =
{
  LUACWRAP_TC_ARRAY,
  "UINT8_32",
  32,
  sizeof(UINT8),
  "$u8"
};

static struct luacwrap_ArrayType regType_UINT16_128 =
{
  LUACWRAP_TC_ARRAY,
  "UINT16_128",
  128,
  sizeof(UINT16),
  "$u16"
};

static struct luacwrap_ArrayType regType_UINT16_32 =
{
  LUACWRAP_TC_ARRAY,
  "UINT16_32",
  32,
  sizeof(UINT16),
  "$u16"
};

static struct luacwrap_ArrayType regType_UINT8_8 =
{
  LUACWRAP_TC_ARRAY,
  "UINT8_8",
  8,
  sizeof(UINT8),
  "$u8"
};


// member descriptors

static luacwrap_RecordMember s_memberGUID[] =
{
  { "Data1", offsetof(GUID, Data1), "$u32"},
  { "Data2", offsetof(GUID, Data2), "$u16"},
  { "Data3", offsetof(GUID, Data3), "$u16"},
  { "Data4", offsetof(GUID, Data4), "UINT8_8"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, GUID);

#if (defined(UNDER_CE))
static luacwrap_RecordMember s_memberMSGQUEUEINFO[] =
{
  { "dwSize", offsetof(MSGQUEUEINFO, dwSize), "$u32"},
  { "dwFlags", offsetof(MSGQUEUEINFO, dwFlags), "$u32"},
  { "dwMaxMessages", offsetof(MSGQUEUEINFO, dwMaxMessages), "$u32"},
  { "cbMaxMessage", offsetof(MSGQUEUEINFO, cbMaxMessage), "$u32"},
  { "dwCurrentMessages", offsetof(MSGQUEUEINFO, dwCurrentMessages), "$u32"},
  { "dwMaxQueueMessages", offsetof(MSGQUEUEINFO, dwMaxQueueMessages), "$u32"},
  { "wNumReaders", offsetof(MSGQUEUEINFO, wNumReaders), "$u16"},
  { "wNumWriters", offsetof(MSGQUEUEINFO, wNumWriters), "$u16"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, MSGQUEUEINFO);
#endif

static luacwrap_RecordMember s_memberTVITEMW[] =
{
  { "mask", offsetof(TVITEMW, mask), "$u32"},
  { "hItem", offsetof(TVITEMW, hItem), "$ptr"},
  { "state", offsetof(TVITEMW, state), "$u32"},
  { "stateMask", offsetof(TVITEMW, stateMask), "$u32"},
  { "pszText", offsetof(TVITEMW, pszText), "$ptr"},
  { "cchTextMax", offsetof(TVITEMW, cchTextMax), "$i32"},
  { "iImage", offsetof(TVITEMW, iImage), "$i32"},
  { "iSelectedImage", offsetof(TVITEMW, iSelectedImage), "$i32"},
  { "cChildren", offsetof(TVITEMW, cChildren), "$i32"},
  { "lParam", offsetof(TVITEMW, lParam), "$ref"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, TVITEMW);

#if (!defined(UNDER_CE))
static luacwrap_RecordMember s_memberLVGROUPMETRICS[] =
{
  { "cbSize", offsetof(LVGROUPMETRICS, cbSize), "$u32"},
  { "mask", offsetof(LVGROUPMETRICS, mask), "$u32"},
  { "Left", offsetof(LVGROUPMETRICS, Left), "$u32"},
  { "Top", offsetof(LVGROUPMETRICS, Top), "$u32"},
  { "Right", offsetof(LVGROUPMETRICS, Right), "$u32"},
  { "Bottom", offsetof(LVGROUPMETRICS, Bottom), "$u32"},
  { "crLeft", offsetof(LVGROUPMETRICS, crLeft), "$u32"},
  { "crTop", offsetof(LVGROUPMETRICS, crTop), "$u32"},
  { "crRight", offsetof(LVGROUPMETRICS, crRight), "$u32"},
  { "crBottom", offsetof(LVGROUPMETRICS, crBottom), "$u32"},
  { "crHeader", offsetof(LVGROUPMETRICS, crHeader), "$u32"},
  { "crFooter", offsetof(LVGROUPMETRICS, crFooter), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, LVGROUPMETRICS);
#endif

static luacwrap_RecordMember s_memberPROCESS_INFORMATION[] =
{
  { "hProcess", offsetof(PROCESS_INFORMATION, hProcess), "$ptr"},
  { "hThread", offsetof(PROCESS_INFORMATION, hThread), "$ptr"},
  { "dwProcessId", offsetof(PROCESS_INFORMATION, dwProcessId), "$u32"},
  { "dwThreadId", offsetof(PROCESS_INFORMATION, dwThreadId), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, PROCESS_INFORMATION);

static luacwrap_RecordMember s_memberLVCOLUMNW[] =
{
  { "mask", offsetof(LVCOLUMNW, mask), "$u32"},
  { "fmt", offsetof(LVCOLUMNW, fmt), "$i32"},
  { "cx", offsetof(LVCOLUMNW, cx), "$i32"},
  { "pszText", offsetof(LVCOLUMNW, pszText), "$ptr"},
  { "cchTextMax", offsetof(LVCOLUMNW, cchTextMax), "$i32"},
  { "iSubItem", offsetof(LVCOLUMNW, iSubItem), "$i32"},
  { "iImage", offsetof(LVCOLUMNW, iImage), "$i32"},
  { "iOrder", offsetof(LVCOLUMNW, iOrder), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, LVCOLUMNW);

#if (defined(USE_AYGSHELL))
static luacwrap_RecordMember s_memberSHINITDLGINFO[] =
{
  { "dwMask", offsetof(SHINITDLGINFO, dwMask), "$u32"},
  { "hDlg", offsetof(SHINITDLGINFO, hDlg), "$ptr"},
  { "dwFlags", offsetof(SHINITDLGINFO, dwFlags), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, SHINITDLGINFO);
#endif

static luacwrap_RecordMember s_memberLOGPEN[] =
{
  { "lopnStyle", offsetof(LOGPEN, lopnStyle), "$u32"},
  { "lopnWidth", offsetof(LOGPEN, lopnWidth), "POINT"},
  { "lopnColor", offsetof(LOGPEN, lopnColor), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, LOGPEN);

static luacwrap_RecordMember s_memberSECURITY_ATTRIBUTES[] =
{
  { "nLength", offsetof(SECURITY_ATTRIBUTES, nLength), "$u32"},
  { "lpSecurityDescriptor", offsetof(SECURITY_ATTRIBUTES, lpSecurityDescriptor), "$ptr"},
  { "bInheritHandle", offsetof(SECURITY_ATTRIBUTES, bInheritHandle), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, SECURITY_ATTRIBUTES);

static luacwrap_RecordMember s_memberLOGFONTW[] =
{
  { "lfHeight", offsetof(LOGFONTW, lfHeight), "$i32"},
  { "lfWidth", offsetof(LOGFONTW, lfWidth), "$i32"},
  { "lfEscapement", offsetof(LOGFONTW, lfEscapement), "$i32"},
  { "lfOrientation", offsetof(LOGFONTW, lfOrientation), "$i32"},
  { "lfWeight", offsetof(LOGFONTW, lfWeight), "$i32"},
  { "lfItalic", offsetof(LOGFONTW, lfItalic), "$u8"},
  { "lfUnderline", offsetof(LOGFONTW, lfUnderline), "$u8"},
  { "lfStrikeOut", offsetof(LOGFONTW, lfStrikeOut), "$u8"},
  { "lfCharSet", offsetof(LOGFONTW, lfCharSet), "$u8"},
  { "lfOutPrecision", offsetof(LOGFONTW, lfOutPrecision), "$u8"},
  { "lfClipPrecision", offsetof(LOGFONTW, lfClipPrecision), "$u8"},
  { "lfQuality", offsetof(LOGFONTW, lfQuality), "$u8"},
  { "lfPitchAndFamily", offsetof(LOGFONTW, lfPitchAndFamily), "$u8"},
  { "lfFaceName", offsetof(LOGFONTW, lfFaceName), "UINT16_32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, LOGFONTW);

#if (defined(UNDER_CE))
static luacwrap_RecordMember s_memberPOWER_BROADCAST[] =
{
  { "Message", offsetof(POWER_BROADCAST, Message), "$u32"},
  { "Flags", offsetof(POWER_BROADCAST, Flags), "$u32"},
  { "Length", offsetof(POWER_BROADCAST, Length), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, POWER_BROADCAST);
#endif

#if (!defined(UNDER_CE))
static luacwrap_RecordMember s_memberNMTCKEYDOWN[] =
{
  { "hdr", offsetof(NMTCKEYDOWN, hdr), "NMHDR"},
  { "wVKey", offsetof(NMTCKEYDOWN, wVKey), "$u16"},
  { "flags", offsetof(NMTCKEYDOWN, flags), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, NMTCKEYDOWN);
#endif

static luacwrap_RecordMember s_memberSTARTUPINFOW[] =
{
  { "cb", offsetof(STARTUPINFOW, cb), "$u32"},
  { "lpReserved", offsetof(STARTUPINFOW, lpReserved), "$ptr"},
  { "lpDesktop", offsetof(STARTUPINFOW, lpDesktop), "$ptr"},
  { "lpTitle", offsetof(STARTUPINFOW, lpTitle), "$ptr"},
  { "dwX", offsetof(STARTUPINFOW, dwX), "$u32"},
  { "dwY", offsetof(STARTUPINFOW, dwY), "$u32"},
  { "dwXSize", offsetof(STARTUPINFOW, dwXSize), "$u32"},
  { "dwYSize", offsetof(STARTUPINFOW, dwYSize), "$u32"},
  { "dwXCountChars", offsetof(STARTUPINFOW, dwXCountChars), "$u32"},
  { "dwYCountChars", offsetof(STARTUPINFOW, dwYCountChars), "$u32"},
  { "dwFillAttribute", offsetof(STARTUPINFOW, dwFillAttribute), "$u32"},
  { "dwFlags", offsetof(STARTUPINFOW, dwFlags), "$u32"},
  { "wShowWindow", offsetof(STARTUPINFOW, wShowWindow), "$u16"},
  { "cbReserved2", offsetof(STARTUPINFOW, cbReserved2), "$u16"},
  { "lpReserved2", offsetof(STARTUPINFOW, lpReserved2), "LPBYTE"},
  { "hStdInput", offsetof(STARTUPINFOW, hStdInput), "$ptr"},
  { "hStdOutput", offsetof(STARTUPINFOW, hStdOutput), "$ptr"},
  { "hStdError", offsetof(STARTUPINFOW, hStdError), "$ptr"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, STARTUPINFOW);

static luacwrap_RecordMember s_memberPOINTS[] =
{
  { "x", offsetof(POINTS, x), "$i16"},
  { "y", offsetof(POINTS, y), "$i16"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, POINTS);

static luacwrap_RecordMember s_memberRECT[] =
{
  { "left", offsetof(RECT, left), "$i32"},
  { "top", offsetof(RECT, top), "$i32"},
  { "right", offsetof(RECT, right), "$i32"},
  { "bottom", offsetof(RECT, bottom), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, RECT);

#if (defined(USE_AYGSHELL))
static luacwrap_RecordMember s_memberSHMENUBARINFO[] =
{
  { "cbSize", offsetof(SHMENUBARINFO, cbSize), "$u32"},
  { "hwndParent", offsetof(SHMENUBARINFO, hwndParent), "$ptr"},
  { "dwFlags", offsetof(SHMENUBARINFO, dwFlags), "$u32"},
  { "nToolBarId", offsetof(SHMENUBARINFO, nToolBarId), "$ptr"},
  { "hInstRes", offsetof(SHMENUBARINFO, hInstRes), "$ptr"},
  { "nBmpId", offsetof(SHMENUBARINFO, nBmpId), "$i32"},
  { "cBmpImages", offsetof(SHMENUBARINFO, cBmpImages), "$i32"},
  { "hwndMB", offsetof(SHMENUBARINFO, hwndMB), "$ptr"},
  { "clrBk", offsetof(SHMENUBARINFO, clrBk), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, SHMENUBARINFO);
#endif

static luacwrap_RecordMember s_memberOSVERSIONINFOW[] =
{
  { "dwOSVersionInfoSize", offsetof(OSVERSIONINFOW, dwOSVersionInfoSize), "$u32"},
  { "dwMajorVersion", offsetof(OSVERSIONINFOW, dwMajorVersion), "$u32"},
  { "dwMinorVersion", offsetof(OSVERSIONINFOW, dwMinorVersion), "$u32"},
  { "dwBuildNumber", offsetof(OSVERSIONINFOW, dwBuildNumber), "$u32"},
  { "dwPlatformId", offsetof(OSVERSIONINFOW, dwPlatformId), "$u32"},
  { "szCSDVersion", offsetof(OSVERSIONINFOW, szCSDVersion), "UINT16_128"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, OSVERSIONINFOW);

static luacwrap_RecordMember s_memberOPENFILENAMEW[] =
{
  { "lStructSize", offsetof(OPENFILENAMEW, lStructSize), "$u32"},
  { "hwndOwner", offsetof(OPENFILENAMEW, hwndOwner), "$ptr"},
  { "hInstance", offsetof(OPENFILENAMEW, hInstance), "$ptr"},
  { "lpstrFilter", offsetof(OPENFILENAMEW, lpstrFilter), "$ptr"},
  { "lpstrCustomFilter", offsetof(OPENFILENAMEW, lpstrCustomFilter), "$ptr"},
  { "nMaxCustFilter", offsetof(OPENFILENAMEW, nMaxCustFilter), "$u32"},
  { "nFilterIndex", offsetof(OPENFILENAMEW, nFilterIndex), "$u32"},
  { "lpstrFile", offsetof(OPENFILENAMEW, lpstrFile), "$ptr"},
  { "nMaxFile", offsetof(OPENFILENAMEW, nMaxFile), "$u32"},
  { "lpstrFileTitle", offsetof(OPENFILENAMEW, lpstrFileTitle), "$ptr"},
  { "nMaxFileTitle", offsetof(OPENFILENAMEW, nMaxFileTitle), "$u32"},
  { "lpstrInitialDir", offsetof(OPENFILENAMEW, lpstrInitialDir), "$ptr"},
  { "lpstrTitle", offsetof(OPENFILENAMEW, lpstrTitle), "$ptr"},
  { "Flags", offsetof(OPENFILENAMEW, Flags), "$u32"},
  { "nFileOffset", offsetof(OPENFILENAMEW, nFileOffset), "$u16"},
  { "nFileExtension", offsetof(OPENFILENAMEW, nFileExtension), "$u16"},
  { "lpstrDefExt", offsetof(OPENFILENAMEW, lpstrDefExt), "$ptr"},
  { "lCustData", offsetof(OPENFILENAMEW, lCustData), "$u32"},
  { "lpTemplateName", offsetof(OPENFILENAMEW, lpTemplateName), "$ptr"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, OPENFILENAMEW);

static luacwrap_RecordMember s_memberTCITEMHEADERW[] =
{
  { "mask", offsetof(TCITEMHEADERW, mask), "$u32"},
  { "lpReserved1", offsetof(TCITEMHEADERW, lpReserved1), "$u32"},
  { "lpReserved2", offsetof(TCITEMHEADERW, lpReserved2), "$u32"},
  { "pszText", offsetof(TCITEMHEADERW, pszText), "$ptr"},
  { "cchTextMax", offsetof(TCITEMHEADERW, cchTextMax), "$i32"},
  { "iImage", offsetof(TCITEMHEADERW, iImage), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, TCITEMHEADERW);

static luacwrap_RecordMember s_memberMENUITEMINFOW[] =
{
  { "cbSize", offsetof(MENUITEMINFOW, cbSize), "$u32"},
  { "fMask", offsetof(MENUITEMINFOW, fMask), "$u32"},
  { "fType", offsetof(MENUITEMINFOW, fType), "$u32"},
  { "fState", offsetof(MENUITEMINFOW, fState), "$u32"},
  { "wID", offsetof(MENUITEMINFOW, wID), "$u32"},
  { "hSubMenu", offsetof(MENUITEMINFOW, hSubMenu), "$ptr"},
  { "hbmpChecked", offsetof(MENUITEMINFOW, hbmpChecked), "$ptr"},
  { "hbmpUnchecked", offsetof(MENUITEMINFOW, hbmpUnchecked), "$ptr"},
  { "dwItemData", offsetof(MENUITEMINFOW, dwItemData), "$ptr"},
  { "dwTypeData", offsetof(MENUITEMINFOW, dwTypeData), "$ptr"},
  { "cch", offsetof(MENUITEMINFOW, cch), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, MENUITEMINFOW);

static luacwrap_RecordMember s_memberCHOOSECOLOR[] =
{
  { "lStructSize", offsetof(CHOOSECOLOR, lStructSize), "$u32"},
  { "hwndOwner", offsetof(CHOOSECOLOR, hwndOwner), "$ptr"},
  { "hInstance", offsetof(CHOOSECOLOR, hInstance), "$ptr"},
  { "rgbResult", offsetof(CHOOSECOLOR, rgbResult), "$u32"},
  { "Flags", offsetof(CHOOSECOLOR, Flags), "$u32"},
  { "lCustData", offsetof(CHOOSECOLOR, lCustData), "$u32"},
  { "lpTemplateName", offsetof(CHOOSECOLOR, lpTemplateName), "LPCTSTR"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, CHOOSECOLOR);

#if (defined(USE_COMMANDBAR))
static luacwrap_RecordMember s_memberCOMMANDBANDSRESTOREINFO[] =
{
  { "cbSize", offsetof(COMMANDBANDSRESTOREINFO, cbSize), "$u32"},
  { "wID", offsetof(COMMANDBANDSRESTOREINFO, wID), "$u32"},
  { "fStyle", offsetof(COMMANDBANDSRESTOREINFO, fStyle), "$u32"},
  { "cxRestored", offsetof(COMMANDBANDSRESTOREINFO, cxRestored), "$u32"},
  { "fMaximized", offsetof(COMMANDBANDSRESTOREINFO, fMaximized), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, COMMANDBANDSRESTOREINFO);
#endif

#if (defined(USE_AYGSHELL))
static luacwrap_RecordMember s_memberSHACTIVATEINFO[] =
{
  { "cbSize", offsetof(SHACTIVATEINFO, cbSize), "$u32"},
  { "hwndLastFocus", offsetof(SHACTIVATEINFO, hwndLastFocus), "$ptr"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, SHACTIVATEINFO);
#endif

#if (defined(UNDER_CE))
static luacwrap_RecordMember s_memberMSGQUEUEOPTIONS[] =
{
  { "dwSize", offsetof(MSGQUEUEOPTIONS, dwSize), "$u32"},
  { "dwFlags", offsetof(MSGQUEUEOPTIONS, dwFlags), "$u32"},
  { "dwMaxMessages", offsetof(MSGQUEUEOPTIONS, dwMaxMessages), "$u32"},
  { "cbMaxMessage", offsetof(MSGQUEUEOPTIONS, cbMaxMessage), "$u32"},
  { "bReadAccess", offsetof(MSGQUEUEOPTIONS, bReadAccess), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, MSGQUEUEOPTIONS);
#endif

static luacwrap_RecordMember s_memberNMHDR[] =
{
  { "hwndFrom", offsetof(NMHDR, hwndFrom), "$ptr"},
  { "idFrom", offsetof(NMHDR, idFrom), "$ptr"},
  { "code", offsetof(NMHDR, code), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, NMHDR);

#if (!defined(UNDER_CE))
static luacwrap_RecordMember s_memberPRINTDLGW[] =
{
  { "lStructSize", offsetof(PRINTDLGW, lStructSize), "$u32"},
  { "hwndOwner", offsetof(PRINTDLGW, hwndOwner), "$ptr"},
  { "hDevMode", offsetof(PRINTDLGW, hDevMode), "HGLOBAL"},
  { "hDevNames", offsetof(PRINTDLGW, hDevNames), "HGLOBAL"},
  { "hDC", offsetof(PRINTDLGW, hDC), "$ptr"},
  { "Flags", offsetof(PRINTDLGW, Flags), "$u32"},
  { "nFromPage", offsetof(PRINTDLGW, nFromPage), "$u16"},
  { "nToPage", offsetof(PRINTDLGW, nToPage), "$u16"},
  { "nMinPage", offsetof(PRINTDLGW, nMinPage), "$u16"},
  { "nMaxPage", offsetof(PRINTDLGW, nMaxPage), "$u16"},
  { "nCopies", offsetof(PRINTDLGW, nCopies), "$u16"},
  { "hInstance", offsetof(PRINTDLGW, hInstance), "$ptr"},
  { "lCustData", offsetof(PRINTDLGW, lCustData), "$u32"},
  { "lpPrintTemplateName", offsetof(PRINTDLGW, lpPrintTemplateName), "$ptr"},
  { "lpSetupTemplateName", offsetof(PRINTDLGW, lpSetupTemplateName), "$ptr"},
  { "hPrintTemplate", offsetof(PRINTDLGW, hPrintTemplate), "HGLOBAL"},
  { "hSetupTemplate", offsetof(PRINTDLGW, hSetupTemplate), "HGLOBAL"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, PRINTDLGW);
#endif

static luacwrap_RecordMember s_memberTCHITTESTINFO[] =
{
  { "pt", offsetof(TCHITTESTINFO, pt), "POINT"},
  { "flags", offsetof(TCHITTESTINFO, flags), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, TCHITTESTINFO);

#if (!defined(UNDER_CE))
static luacwrap_RecordMember s_memberNMITEMACTIVATE[] =
{
  { "hdr", offsetof(NMITEMACTIVATE, hdr), "NMHDR"},
  { "iItem", offsetof(NMITEMACTIVATE, iItem), "$i32"},
  { "iSubItem", offsetof(NMITEMACTIVATE, iSubItem), "$i32"},
  { "uNewState", offsetof(NMITEMACTIVATE, uNewState), "$u32"},
  { "uOldState", offsetof(NMITEMACTIVATE, uOldState), "$u32"},
  { "uChanged", offsetof(NMITEMACTIVATE, uChanged), "$u32"},
  { "ptAction", offsetof(NMITEMACTIVATE, ptAction), "POINT"},
  { "lParam", offsetof(NMITEMACTIVATE, lParam), "$ref"},
  { "uKeyFlags", offsetof(NMITEMACTIVATE, uKeyFlags), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, NMITEMACTIVATE);
#endif

static luacwrap_RecordMember s_memberCOPYDATASTRUCT[] =
{
  { "dwData", offsetof(COPYDATASTRUCT, dwData), "$ptr"},
  { "cbData", offsetof(COPYDATASTRUCT, cbData), "$u32"},
  { "lpData", offsetof(COPYDATASTRUCT, lpData), "$ptr"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, COPYDATASTRUCT);

static luacwrap_RecordMember s_memberTBBUTTONINFOW[] =
{
  { "cbSize", offsetof(TBBUTTONINFOW, cbSize), "$u32"},
  { "dwMask", offsetof(TBBUTTONINFOW, dwMask), "$u32"},
  { "idCommand", offsetof(TBBUTTONINFOW, idCommand), "$i32"},
  { "iImage", offsetof(TBBUTTONINFOW, iImage), "$i32"},
  { "fsState", offsetof(TBBUTTONINFOW, fsState), "$u8"},
  { "fsStyle", offsetof(TBBUTTONINFOW, fsStyle), "$u8"},
  { "cx", offsetof(TBBUTTONINFOW, cx), "$u16"},
  { "lParam", offsetof(TBBUTTONINFOW, lParam), "DWORD_PTR"},
  { "pszText", offsetof(TBBUTTONINFOW, pszText), "$ptr"},
  { "cchText", offsetof(TBBUTTONINFOW, cchText), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, TBBUTTONINFOW);

#if (!defined(UNDER_CE))
static luacwrap_RecordMember s_memberWNDCLASSEXW[] =
{
  { "cbSize", offsetof(WNDCLASSEXW, cbSize), "$u32"},
  { "style", offsetof(WNDCLASSEXW, style), "$u32"},
  { "lpfnWndProc", offsetof(WNDCLASSEXW, lpfnWndProc), "$ptr"},
  { "cbClsExtra", offsetof(WNDCLASSEXW, cbClsExtra), "$i32"},
  { "cbWndExtra", offsetof(WNDCLASSEXW, cbWndExtra), "$i32"},
  { "hInstance", offsetof(WNDCLASSEXW, hInstance), "$ptr"},
  { "hIcon", offsetof(WNDCLASSEXW, hIcon), "$ptr"},
  { "hCursor", offsetof(WNDCLASSEXW, hCursor), "$ptr"},
  { "hbrBackground", offsetof(WNDCLASSEXW, hbrBackground), "$ptr"},
  { "lpszMenuName", offsetof(WNDCLASSEXW, lpszMenuName), "$ptr"},
  { "lpszClassName", offsetof(WNDCLASSEXW, lpszClassName), "$ptr"},
  { "hIconSm", offsetof(WNDCLASSEXW, hIconSm), "$ptr"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, WNDCLASSEXW);
#endif

static luacwrap_RecordMember s_memberACCEL[] =
{
  { "fVirt", offsetof(ACCEL, fVirt), "$u8"},
  { "key", offsetof(ACCEL, key), "$u16"},
  { "cmd", offsetof(ACCEL, cmd), "$u16"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, ACCEL);

#if (defined(UNDER_CE))
static luacwrap_RecordMember s_memberCONNMGR_CONNECTIONINFO[] =
{
  { "cbSize", offsetof(CONNMGR_CONNECTIONINFO, cbSize), "$u32"},
  { "dwParams", offsetof(CONNMGR_CONNECTIONINFO, dwParams), "$u32"},
  { "dwFlags", offsetof(CONNMGR_CONNECTIONINFO, dwFlags), "$u32"},
  { "dwPriority", offsetof(CONNMGR_CONNECTIONINFO, dwPriority), "$u32"},
  { "bExclusive", offsetof(CONNMGR_CONNECTIONINFO, bExclusive), "$i32"},
  { "bDisabled", offsetof(CONNMGR_CONNECTIONINFO, bDisabled), "$i32"},
  { "guidDestNet", offsetof(CONNMGR_CONNECTIONINFO, guidDestNet), "GUID"},
  { "hWnd", offsetof(CONNMGR_CONNECTIONINFO, hWnd), "$ptr"},
  { "uMsg", offsetof(CONNMGR_CONNECTIONINFO, uMsg), "$u32"},
  { "lParam", offsetof(CONNMGR_CONNECTIONINFO, lParam), "$u32"},
  { "ulMaxCost", offsetof(CONNMGR_CONNECTIONINFO, ulMaxCost), "$u32"},
  { "ulMinRcvBw", offsetof(CONNMGR_CONNECTIONINFO, ulMinRcvBw), "$u32"},
  { "ulMaxConnLatency", offsetof(CONNMGR_CONNECTIONINFO, ulMaxConnLatency), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, CONNMGR_CONNECTIONINFO);
#endif

static luacwrap_RecordMember s_memberPOINT[] =
{
  { "x", offsetof(POINT, x), "$i32"},
  { "y", offsetof(POINT, y), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, POINT);

static luacwrap_RecordMember s_memberCREATESTRUCTW[] =
{
  { "lpCreateParams", offsetof(CREATESTRUCTW, lpCreateParams), "$ref"},
  { "hInstance", offsetof(CREATESTRUCTW, hInstance), "$ptr"},
  { "hMenu", offsetof(CREATESTRUCTW, hMenu), "$ptr"},
  { "hwndParent", offsetof(CREATESTRUCTW, hwndParent), "$ptr"},
  { "cy", offsetof(CREATESTRUCTW, cy), "$i32"},
  { "cx", offsetof(CREATESTRUCTW, cx), "$i32"},
  { "y", offsetof(CREATESTRUCTW, y), "$i32"},
  { "x", offsetof(CREATESTRUCTW, x), "$i32"},
  { "style", offsetof(CREATESTRUCTW, style), "$i32"},
  { "lpszName", offsetof(CREATESTRUCTW, lpszName), "$ptr"},
  { "lpszClass", offsetof(CREATESTRUCTW, lpszClass), "$ptr"},
  { "dwExStyle", offsetof(CREATESTRUCTW, dwExStyle), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, CREATESTRUCTW);

static luacwrap_RecordMember s_memberTVINSERTSTRUCTW[] =
{
  { "hParent", offsetof(TVINSERTSTRUCTW, hParent), "$ptr"},
  { "hInsertAfter", offsetof(TVINSERTSTRUCTW, hInsertAfter), "$ptr"},
  { "item", offsetof(TVINSERTSTRUCTW, item), "TVITEMW"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, TVINSERTSTRUCTW);

static luacwrap_RecordMember s_memberDLGTEMPLATE[] =
{
  { "style", offsetof(DLGTEMPLATE, style), "$u32"},
  { "dwExtendedStyle", offsetof(DLGTEMPLATE, dwExtendedStyle), "$u32"},
  { "cdit", offsetof(DLGTEMPLATE, cdit), "$u16"},
  { "x", offsetof(DLGTEMPLATE, x), "$i16"},
  { "y", offsetof(DLGTEMPLATE, y), "$i16"},
  { "cx", offsetof(DLGTEMPLATE, cx), "$i16"},
  { "cy", offsetof(DLGTEMPLATE, cy), "$i16"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, DLGTEMPLATE);

static luacwrap_RecordMember s_memberPAINTSTRUCT[] =
{
  { "hdc", offsetof(PAINTSTRUCT, hdc), "$ptr"},
  { "fErase", offsetof(PAINTSTRUCT, fErase), "$i32"},
  { "rcPaint", offsetof(PAINTSTRUCT, rcPaint), "RECT"},
  { "fRestore", offsetof(PAINTSTRUCT, fRestore), "$i32"},
  { "fIncUpdate", offsetof(PAINTSTRUCT, fIncUpdate), "$i32"},
  { "rgbReserved", offsetof(PAINTSTRUCT, rgbReserved), "UINT8_32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, PAINTSTRUCT);

static luacwrap_RecordMember s_memberTPMPARAMS[] =
{
  { "cbSize", offsetof(TPMPARAMS, cbSize), "$u32"},
  { "rcExclude", offsetof(TPMPARAMS, rcExclude), "RECT"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, TPMPARAMS);

static luacwrap_RecordMember s_memberSIZE[] =
{
  { "cx", offsetof(SIZE, cx), "$i32"},
  { "cy", offsetof(SIZE, cy), "$i32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, SIZE);

#if (!defined(UNDER_CE))
static luacwrap_RecordMember s_memberLVGROUP[] =
{
  { "cbSize", offsetof(LVGROUP, cbSize), "$u32"},
  { "mask", offsetof(LVGROUP, mask), "$u32"},
  { "pszHeader", offsetof(LVGROUP, pszHeader), "$ptr"},
  { "cchHeader", offsetof(LVGROUP, cchHeader), "$i32"},
  { "pszFooter", offsetof(LVGROUP, pszFooter), "$ptr"},
  { "cchFooter", offsetof(LVGROUP, cchFooter), "$i32"},
  { "iGroupId", offsetof(LVGROUP, iGroupId), "$i32"},
  { "stateMask", offsetof(LVGROUP, stateMask), "$u32"},
  { "state", offsetof(LVGROUP, state), "$u32"},
  { "uAlign", offsetof(LVGROUP, uAlign), "$u32"},
  { "pszSubtitle", offsetof(LVGROUP, pszSubtitle), "$ptr"},
  { "cchSubtitle", offsetof(LVGROUP, cchSubtitle), "$u32"},
  { "pszTask", offsetof(LVGROUP, pszTask), "$ptr"},
  { "cchTask", offsetof(LVGROUP, cchTask), "$u32"},
  { "pszDescriptionTop", offsetof(LVGROUP, pszDescriptionTop), "$ptr"},
  { "cchDescriptionTop", offsetof(LVGROUP, cchDescriptionTop), "$u32"},
  { "pszDescriptionBottom", offsetof(LVGROUP, pszDescriptionBottom), "$ptr"},
  { "cchDescriptionBottom", offsetof(LVGROUP, cchDescriptionBottom), "$u32"},
  { "iTitleImage", offsetof(LVGROUP, iTitleImage), "$i32"},
  { "iExtendedImage", offsetof(LVGROUP, iExtendedImage), "$i32"},
  { "iFirstItem", offsetof(LVGROUP, iFirstItem), "$i32"},
  { "cItems", offsetof(LVGROUP, cItems), "$u32"},
  { "pszSubsetTitle", offsetof(LVGROUP, pszSubsetTitle), "$ptr"},
  { "cchSubsetTitle", offsetof(LVGROUP, cchSubsetTitle), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, LVGROUP);
#endif

static luacwrap_RecordMember s_memberNMLVKEYDOWN[] =
{
  { "hdr", offsetof(NMLVKEYDOWN, hdr), "NMHDR"},
  { "wVKey", offsetof(NMLVKEYDOWN, wVKey), "$u16"},
  { "flags", offsetof(NMLVKEYDOWN, flags), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, NMLVKEYDOWN);

static luacwrap_RecordMember s_memberNMLISTVIEW[] =
{
  { "hdr", offsetof(NMLISTVIEW, hdr), "NMHDR"},
  { "iItem", offsetof(NMLISTVIEW, iItem), "$i32"},
  { "iSubItem", offsetof(NMLISTVIEW, iSubItem), "$i32"},
  { "uNewState", offsetof(NMLISTVIEW, uNewState), "$u32"},
  { "uOldState", offsetof(NMLISTVIEW, uOldState), "$u32"},
  { "uChanged", offsetof(NMLISTVIEW, uChanged), "$u32"},
  { "ptAction", offsetof(NMLISTVIEW, ptAction), "POINT"},
  { "lParam", offsetof(NMLISTVIEW, lParam), "$ref"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, NMLISTVIEW);

static luacwrap_RecordMember s_memberDLGITEMTEMPLATE[] =
{
  { "style", offsetof(DLGITEMTEMPLATE, style), "$u32"},
  { "dwExtendedStyle", offsetof(DLGITEMTEMPLATE, dwExtendedStyle), "$u32"},
  { "x", offsetof(DLGITEMTEMPLATE, x), "$i16"},
  { "y", offsetof(DLGITEMTEMPLATE, y), "$i16"},
  { "cx", offsetof(DLGITEMTEMPLATE, cx), "$i16"},
  { "cy", offsetof(DLGITEMTEMPLATE, cy), "$i16"},
  { "id", offsetof(DLGITEMTEMPLATE, id), "$u16"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, DLGITEMTEMPLATE);

static luacwrap_RecordMember s_memberNMTREEVIEWW[] =
{
  { "hdr", offsetof(NMTREEVIEWW, hdr), "NMHDR"},
  { "action", offsetof(NMTREEVIEWW, action), "$u32"},
  { "itemOld", offsetof(NMTREEVIEWW, itemOld), "TVITEMW"},
  { "itemNew", offsetof(NMTREEVIEWW, itemNew), "TVITEMW"},
  { "ptDrag", offsetof(NMTREEVIEWW, ptDrag), "POINT"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, NMTREEVIEWW);

#if (!defined(UNDER_CE))
static luacwrap_RecordMember s_memberWINDOWPLACEMENT[] =
{
  { "length", offsetof(WINDOWPLACEMENT, length), "$u32"},
  { "flags", offsetof(WINDOWPLACEMENT, flags), "$u32"},
  { "showCmd", offsetof(WINDOWPLACEMENT, showCmd), "$u32"},
  { "ptMinPosition", offsetof(WINDOWPLACEMENT, ptMinPosition), "POINT"},
  { "ptMaxPosition", offsetof(WINDOWPLACEMENT, ptMaxPosition), "POINT"},
  { "rcNormalPosition", offsetof(WINDOWPLACEMENT, rcNormalPosition), "RECT"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, WINDOWPLACEMENT);
#endif

static luacwrap_RecordMember s_memberNMLVDISPINFOW[] =
{
  { "hdr", offsetof(NMLVDISPINFOW, hdr), "NMHDR"},
  { "item", offsetof(NMLVDISPINFOW, item), "LVITEMW"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, NMLVDISPINFOW);

static luacwrap_RecordMember s_memberMSG[] =
{
  { "hwnd", offsetof(MSG, hwnd), "$ptr"},
  { "message", offsetof(MSG, message), "$u32"},
  { "wParam", offsetof(MSG, wParam), "$u32"},
  { "lParam", offsetof(MSG, lParam), "$u32"},
  { "time", offsetof(MSG, time), "$u32"},
  { "pt", offsetof(MSG, pt), "POINT"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, MSG);

static luacwrap_RecordMember s_memberTCITEMW[] =
{
  { "mask", offsetof(TCITEMW, mask), "$u32"},
  { "dwState", offsetof(TCITEMW, dwState), "$u32"},
  { "dwStateMask", offsetof(TCITEMW, dwStateMask), "$u32"},
  { "pszText", offsetof(TCITEMW, pszText), "$ptr"},
  { "cchTextMax", offsetof(TCITEMW, cchTextMax), "$i32"},
  { "iImage", offsetof(TCITEMW, iImage), "$i32"},
  { "lParam", offsetof(TCITEMW, lParam), "$u32"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, TCITEMW);

static luacwrap_RecordMember s_memberLVITEMW[] =
{
  { "mask", offsetof(LVITEMW, mask), "$u32"},
  { "iItem", offsetof(LVITEMW, iItem), "$i32"},
  { "iSubItem", offsetof(LVITEMW, iSubItem), "$i32"},
  { "state", offsetof(LVITEMW, state), "$u32"},
  { "stateMask", offsetof(LVITEMW, stateMask), "$u32"},
  { "pszText", offsetof(LVITEMW, pszText), "$ptr"},
  { "cchTextMax", offsetof(LVITEMW, cchTextMax), "$i32"},
  { "iImage", offsetof(LVITEMW, iImage), "$i32"},
  { "lParam", offsetof(LVITEMW, lParam), "$ref"},
  { "iIndent", offsetof(LVITEMW, iIndent), "$i32"},
#if (!defined(UNDER_CE))
  { "iGroupId", offsetof(LVITEMW, iGroupId), "$i32"},
#endif
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, LVITEMW);

static luacwrap_RecordMember s_memberWNDCLASSW[] =
{
  { "style", offsetof(WNDCLASSW, style), "$u32"},
  { "lpfnWndProc", offsetof(WNDCLASSW, lpfnWndProc), "$ptr"},
  { "cbClsExtra", offsetof(WNDCLASSW, cbClsExtra), "$i32"},
  { "cbWndExtra", offsetof(WNDCLASSW, cbWndExtra), "$i32"},
  { "hInstance", offsetof(WNDCLASSW, hInstance), "$ptr"},
  { "hIcon", offsetof(WNDCLASSW, hIcon), "$ptr"},
  { "hCursor", offsetof(WNDCLASSW, hCursor), "$ptr"},
  { "hbrBackground", offsetof(WNDCLASSW, hbrBackground), "$ptr"},
  { "lpszMenuName", offsetof(WNDCLASSW, lpszMenuName), "$ptr"},
  { "lpszClassName", offsetof(WNDCLASSW, lpszClassName), "$ptr"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, WNDCLASSW);

#if (!defined(UNDER_CE))
static luacwrap_RecordMember s_memberOSVERSIONINFOEXW[] =
{
  { "dwOSVersionInfoSize", offsetof(OSVERSIONINFOEXW, dwOSVersionInfoSize), "$u32"},
  { "dwMajorVersion", offsetof(OSVERSIONINFOEXW, dwMajorVersion), "$u32"},
  { "dwMinorVersion", offsetof(OSVERSIONINFOEXW, dwMinorVersion), "$u32"},
  { "dwBuildNumber", offsetof(OSVERSIONINFOEXW, dwBuildNumber), "$u32"},
  { "dwPlatformId", offsetof(OSVERSIONINFOEXW, dwPlatformId), "$u32"},
  { "szCSDVersion", offsetof(OSVERSIONINFOEXW, szCSDVersion), "UINT16_128"},
  { "wServicePackMajor", offsetof(OSVERSIONINFOEXW, wServicePackMajor), "$u16"},
  { "wServicePackMinor", offsetof(OSVERSIONINFOEXW, wServicePackMinor), "$u16"},
  { "wSuiteMask", offsetof(OSVERSIONINFOEXW, wSuiteMask), "$u16"},
  { "wProductType", offsetof(OSVERSIONINFOEXW, wProductType), "$u8"},
  { "wReserved", offsetof(OSVERSIONINFOEXW, wReserved), "$u8"},
  { NULL, 0 }
};

LUACWRAP_DEFINESTRUCT(winapi, OSVERSIONINFOEXW);
#endif

int lua_tolwparam( lua_State *L, int idx )
{
  int v = 0;
  switch (lua_type(L, idx))
  {
    case LUA_TLIGHTUSERDATA:
    case LUA_TUSERDATA:
    {
      v = (int)lua_touserdata(L, idx);
    }
    break;
    case LUA_TSTRING:
    {
      v = (int)lua_tostring(L, idx);
    }
    break;
    case LUA_TNUMBER:
    {
      v = lua_tointeger(L, idx);
    }
    break;
  }
  return v;
} 

int lua_tohandle( lua_State *L, int idx )
{
  int v = 0;
  switch (lua_type(L, idx))
  {
    case LUA_TLIGHTUSERDATA:
    case LUA_TUSERDATA:
    {
      v = (int)lua_touserdata(L, idx);
    }
    break;
    case LUA_TNUMBER:
    {
      v = lua_tointeger(L, idx);
    }
    break;
  }
  return v;
} 

int lua_toresourceref( lua_State *L, int idx )
{
  int v = 0;
  switch (lua_type(L, idx))
  {
    case LUA_TSTRING:
    {
      v = (int)lua_tostring(L, idx);
    }
    break;
    case LUA_TNUMBER:
    {
      v = lua_tointeger(L, idx);
    }
    break;
  }
  return v;
} 

#define LUA_WIN32GUI_LIBNAME "winapi"
#define LUA_WIN32GUI_VERSION "winapi version 1.0"

int luawrap_version( lua_State *L )
{
  lua_pushstring( L, LUA_WIN32GUI_VERSION);
  return 1;
}

int winapi_ProcessMessages( lua_State *L )
{
  MSG msg;
  while(GetMessage(&msg, NULL, 0, 0))
  {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
  }

  lua_pushnumber(L, msg.wParam);
  return 1;
}

int winapi_GetLastError( lua_State *L )
{
  int numret = 0;
  DWORD retval;


  retval = 
    GetLastError(
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_SetLastError( lua_State *L )
{
  int numret = 0;
  DWORD p1;

  p1 = (DWORD)lua_tonumber(L, 1);

    SetLastError(
      p1
    );

  return numret;
}

int winapi_GetModuleHandleW( lua_State *L )
{
  int numret = 0;
  HMODULE retval;
  LPCWSTR p1 = 0;

  if (!lua_isnil(L, 1))
  {
    p1 = (LPCWSTR)lua_tostring(L, 1);
  }

  retval = 
    GetModuleHandleW(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_OutputDebugStringA( lua_State *L )
{
  int numret = 0;
  LPCSTR p1;

  p1 = (LPCSTR)lua_tostring(L, 1);

    OutputDebugStringA(
      p1
    );

  return numret;
}

#endif
int winapi_OutputDebugStringW( lua_State *L )
{
  int numret = 0;
  LPCWSTR p1;

  p1 = (LPCWSTR)lua_tostring(L, 1);

    OutputDebugStringW(
      p1
    );

  return numret;
}

int winapi_GetVersionExW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  OSVERSIONINFOW* p1;

  p1 = (OSVERSIONINFOW*)luacwrap_checktype(L, 1, &regType_OSVERSIONINFOW.hdr);

  retval = 
    GetVersionExW(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_CreateProcessW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  LPCWSTR p1 = 0;
  LPWSTR p2 = 0;
  SECURITY_ATTRIBUTES* p3 = 0;
  SECURITY_ATTRIBUTES* p4 = 0;
  BOOL p5;
  DWORD p6;
  LPVOID p7 = 0;
  LPCWSTR p8 = 0;
  STARTUPINFOW* p9 = 0;
  PROCESS_INFORMATION* p10 = 0;

  if (!lua_isnil(L, 1))
  {
    p1 = (LPCWSTR)lua_tostring(L, 1);
  }
  if (!lua_isnil(L, 2))
  {
    p2 = (LPWSTR)lua_tostring(L, 2);
  }
  if (!lua_isnil(L, 3))
  {
    p3 = (SECURITY_ATTRIBUTES*)luacwrap_checktype(L, 3, &regType_SECURITY_ATTRIBUTES.hdr);
  }
  if (!lua_isnil(L, 4))
  {
    p4 = (SECURITY_ATTRIBUTES*)luacwrap_checktype(L, 4, &regType_SECURITY_ATTRIBUTES.hdr);
  }
  p5 = lua_tointeger(L, 5);
  p6 = (DWORD)lua_tonumber(L, 6);
  if (!lua_isnil(L, 7))
  {
    p7 = (LPVOID)lua_touserdata(L, 7);
  }
  if (!lua_isnil(L, 8))
  {
    p8 = (LPCWSTR)lua_tostring(L, 8);
  }
  if (!lua_isnil(L, 9))
  {
    p9 = (STARTUPINFOW*)luacwrap_checktype(L, 9, &regType_STARTUPINFOW.hdr);
  }
  if (!lua_isnil(L, 10))
  {
    p10 = (PROCESS_INFORMATION*)luacwrap_checktype(L, 10, &regType_PROCESS_INFORMATION.hdr);
  }

  retval = 
    CreateProcessW(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9,
      p10
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_Sleep( lua_State *L )
{
  int numret = 0;
  DWORD p1;

  p1 = (DWORD)lua_tonumber(L, 1);

    Sleep(
      p1
    );

  return numret;
}

int winapi_CreateMutexW( lua_State *L )
{
  int numret = 0;
  HANDLE retval;
  SECURITY_ATTRIBUTES* p1 = 0;
  BOOL p2;
  LPCWSTR p3;

  if (!lua_isnil(L, 1))
  {
    p1 = (SECURITY_ATTRIBUTES*)luacwrap_checktype(L, 1, &regType_SECURITY_ATTRIBUTES.hdr);
  }
  p2 = lua_tointeger(L, 2);
  p3 = (LPCWSTR)lua_tostring(L, 3);

  retval = 
    CreateMutexW(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_CreateEventW( lua_State *L )
{
  int numret = 0;
  HANDLE retval;
  SECURITY_ATTRIBUTES* p1 = 0;
  BOOL p2;
  BOOL p3;
  LPCWSTR p4;

  if (!lua_isnil(L, 1))
  {
    p1 = (SECURITY_ATTRIBUTES*)luacwrap_checktype(L, 1, &regType_SECURITY_ATTRIBUTES.hdr);
  }
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (LPCWSTR)lua_tostring(L, 4);

  retval = 
    CreateEventW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_OpenEventW( lua_State *L )
{
  int numret = 0;
  HANDLE retval;
  DWORD p1;
  BOOL p2;
  LPCWSTR p3;

  p1 = (DWORD)lua_tonumber(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = (LPCWSTR)lua_tostring(L, 3);

  retval = 
    OpenEventW(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_CreateSemaphoreW( lua_State *L )
{
  int numret = 0;
  HANDLE retval;
  SECURITY_ATTRIBUTES* p1 = 0;
  LONG p2;
  LONG p3;
  LPCWSTR p4;

  if (!lua_isnil(L, 1))
  {
    p1 = (SECURITY_ATTRIBUTES*)luacwrap_checktype(L, 1, &regType_SECURITY_ATTRIBUTES.hdr);
  }
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (LPCWSTR)lua_tostring(L, 4);

  retval = 
    CreateSemaphoreW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_SetEvent( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HANDLE p1;

  p1 = (HANDLE)lua_tohandle(L, 1);

  retval = 
    SetEvent(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ResetEvent( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HANDLE p1;

  p1 = (HANDLE)lua_tohandle(L, 1);

  retval = 
    ResetEvent(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_PulseEvent( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HANDLE p1;

  p1 = (HANDLE)lua_tohandle(L, 1);

  retval = 
    PulseEvent(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ReleaseSemaphore( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HANDLE p1;
  LONG p2;
  LONG p3;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    ReleaseSemaphore(
      p1,
      p2,
      &p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ReleaseMutex( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HANDLE p1;

  p1 = (HANDLE)lua_tohandle(L, 1);

  retval = 
    ReleaseMutex(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_WaitForSingleObject( lua_State *L )
{
  int numret = 0;
  DWORD retval;
  HANDLE p1;
  DWORD p2;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    WaitForSingleObject(
      p1,
      p2
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_GetExitCodeThread( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HANDLE p1;
  DWORD p2;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    GetExitCodeThread(
      p1,
      &p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetExitCodeProcess( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HANDLE p1;
  DWORD p2;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    GetExitCodeProcess(
      p1,
      &p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_RegisterClassW( lua_State *L )
{
  int numret = 0;
  ATOM retval;
  WNDCLASSW* p1;

  p1 = (WNDCLASSW*)luacwrap_checktype(L, 1, &regType_WNDCLASSW.hdr);

  retval = 
    RegisterClassW(
      p1
    );

  // marshal retval  
  if (0 == retval)
  {
    lua_pushnil(L);
  }
  else
  {
    lua_pushlightuserdata(L, (PVOID)retval);
  }
  ++numret;

  return numret;
}

int winapi_UnregisterClassW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  LPCWSTR p1;
  HINSTANCE p2;

  p1 = (LPCWSTR)lua_tostring(L, 1);
  p2 = (HINSTANCE)lua_tohandle(L, 2);

  retval = 
    UnregisterClassW(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetClassInfoW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HINSTANCE p1;
  LPCWSTR p2;
  WNDCLASSW* p3;

  p1 = (HINSTANCE)lua_tohandle(L, 1);
  p2 = (LPCWSTR)lua_tostring(L, 2);
  p3 = (WNDCLASSW*)luacwrap_checktype(L, 3, &regType_WNDCLASSW.hdr);

  retval = 
    GetClassInfoW(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_RegisterClassExW( lua_State *L )
{
  int numret = 0;
  ATOM retval;
  WNDCLASSEXW* p1;

  p1 = (WNDCLASSEXW*)luacwrap_checktype(L, 1, &regType_WNDCLASSEXW.hdr);

  retval = 
    RegisterClassExW(
      p1
    );

  // marshal retval  
  if (0 == retval)
  {
    lua_pushnil(L);
  }
  else
  {
    lua_pushlightuserdata(L, (PVOID)retval);
  }
  ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_GetClassInfoExW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HINSTANCE p1;
  LPCWSTR p2;
  WNDCLASSEXW* p3;

  p1 = (HINSTANCE)lua_tohandle(L, 1);
  p2 = (LPCWSTR)lua_tostring(L, 2);
  p3 = (WNDCLASSEXW*)luacwrap_checktype(L, 3, &regType_WNDCLASSEXW.hdr);

  retval = 
    GetClassInfoExW(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_CreateWindowExW( lua_State *L )
{
  int numret = 0;
  HWND retval;
  DWORD p1;
  LPCWSTR p2;
  LPCWSTR p3;
  DWORD p4;
  int p5;
  int p6;
  int p7;
  int p8;
  HWND p9;
  HMENU p10;
  HINSTANCE p11;
  PVOID p12;

  p1 = (DWORD)lua_tonumber(L, 1);
  p2 = (LPCWSTR)lua_tostring(L, 2);
  p3 = (LPCWSTR)lua_tostring(L, 3);
  p4 = (DWORD)lua_tonumber(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);
  p7 = lua_tointeger(L, 7);
  p8 = lua_tointeger(L, 8);
  p9 = lua_toWindow(L, 9);
  p10 = (HMENU)lua_tohandle(L, 10);
  p11 = (HINSTANCE)lua_tohandle(L, 11);
  p12 = (PVOID)luacwrap_createreference(L, 12);

  retval = 
    CreateWindowExW(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9,
      p10,
      p11,
      p12
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_GetDesktopWindow( lua_State *L )
{
  int numret = 0;
  HWND retval;


  retval = 
    GetDesktopWindow(
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_IsWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    IsWindow(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_IsWindowVisible( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    IsWindowVisible(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_IsWindowEnabled( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    IsWindowEnabled(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_IsChild( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  HWND p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_toWindow(L, 2);

  retval = 
    IsChild(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_DestroyWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    DestroyWindow(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ShowWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  int p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    ShowWindow(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_EnableWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  int p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    EnableWindow(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_UpdateWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    UpdateWindow(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_RedrawWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  RECT* p2;
  HRGN p3;
  UINT p4;

  p1 = lua_toWindow(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);
  p3 = lua_toRegion(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);

  retval = 
    RedrawWindow(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_SetParent( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;
  HWND p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_toWindow(L, 2);

  retval = 
    SetParent(
      p1,
      p2
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_GetParent( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    GetParent(
      p1
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_FindWindowW( lua_State *L )
{
  int numret = 0;
  HWND retval;
  LPCWSTR p1;
  LPCWSTR p2;

  p1 = (LPCWSTR)lua_tostring(L, 1);
  p2 = (LPCWSTR)lua_tostring(L, 2);

  retval = 
    FindWindowW(
      p1,
      p2
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_SetActiveWindow( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    SetActiveWindow(
      p1
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_GetActiveWindow( lua_State *L )
{
  int numret = 0;
  HWND retval;


  retval = 
    GetActiveWindow(
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_GetKeyState( lua_State *L )
{
  int numret = 0;
  SHORT retval;
  int p1;

  p1 = lua_tointeger(L, 1);

  retval = 
    GetKeyState(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetAsyncKeyState( lua_State *L )
{
  int numret = 0;
  SHORT retval;
  int p1;

  p1 = lua_tointeger(L, 1);

  retval = 
    GetAsyncKeyState(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_DrawMenuBar( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    DrawMenuBar(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_CreateMenu( lua_State *L )
{
  int numret = 0;
  HMENU retval;


  retval = 
    CreateMenu(
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_CreatePopupMenu( lua_State *L )
{
  int numret = 0;
  HMENU retval;


  retval = 
    CreatePopupMenu(
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_DestroyMenu( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;

  p1 = (HMENU)lua_tohandle(L, 1);

  retval = 
    DestroyMenu(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_CheckMenuItem( lua_State *L )
{
  int numret = 0;
  DWORD retval;
  HMENU p1;
  UINT p2;
  UINT p3;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);

  retval = 
    CheckMenuItem(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_EnableMenuItem( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  UINT p3;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);

  retval = 
    EnableMenuItem(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetSubMenu( lua_State *L )
{
  int numret = 0;
  HMENU retval;
  HMENU p1;
  int p2;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    GetSubMenu(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_GetMenuItemID( lua_State *L )
{
  int numret = 0;
  UINT retval;
  HMENU p1;
  int p2;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    GetMenuItemID(
      p1,
      p2
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_GetMenuItemCount( lua_State *L )
{
  int numret = 0;
  int retval;
  HMENU p1;

  p1 = (HMENU)lua_tohandle(L, 1);

  retval = 
    GetMenuItemCount(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_InsertMenuW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  UINT p3;
  UINT_PTR p4;
  LPCWSTR p5;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (UINT_PTR)lua_tohandle(L, 4);
  p5 = (LPCWSTR)lua_tostring(L, 5);

  retval = 
    InsertMenuW(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_AppendMenuW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  UINT_PTR p3;
  LPCWSTR p4;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (UINT_PTR)lua_tohandle(L, 3);
  p4 = (LPCWSTR)lua_tostring(L, 4);

  retval = 
    AppendMenuW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_RemoveMenu( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  UINT p3;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);

  retval = 
    RemoveMenu(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_DeleteMenu( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  UINT p3;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);

  retval = 
    DeleteMenu(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_TrackPopupMenu( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  int p3;
  int p4;
  int p5;
  HWND p6;
  RECT* p7;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_toWindow(L, 6);
  p7 = (RECT*)luacwrap_checktype(L, 7, &regType_RECT.hdr);

  retval = 
    TrackPopupMenu(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_TrackPopupMenuEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  int p3;
  int p4;
  HWND p5;
  TPMPARAMS* p6;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_toWindow(L, 5);
  p6 = (TPMPARAMS*)luacwrap_checktype(L, 6, &regType_TPMPARAMS.hdr);

  retval = 
    TrackPopupMenuEx(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_InsertMenuItemW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  BOOL p3;
  MENUITEMINFOW* p4;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (MENUITEMINFOW*)luacwrap_checktype(L, 4, &regType_MENUITEMINFOW.hdr);

  retval = 
    InsertMenuItemW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_GetMenuItemInfoW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  BOOL p3;
  MENUITEMINFOW* p4;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (MENUITEMINFOW*)luacwrap_checktype(L, 4, &regType_MENUITEMINFOW.hdr);

  retval = 
    GetMenuItemInfoW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_SetMenuItemInfoW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  BOOL p3;
  MENUITEMINFOW* p4;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (MENUITEMINFOW*)luacwrap_checktype(L, 4, &regType_MENUITEMINFOW.hdr);

  retval = 
    SetMenuItemInfoW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_IsMenu( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;

  p1 = (HMENU)lua_tohandle(L, 1);

  retval = 
    IsMenu(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_CloseWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    CloseWindow(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_SetMenuItemBitmaps( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  UINT p3;
  HBITMAP p4;
  HBITMAP p5;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (HBITMAP)lua_tohandle(L, 4);
  p5 = (HBITMAP)lua_tohandle(L, 5);

  retval = 
    SetMenuItemBitmaps(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_GetMenuCheckMarkDimensions( lua_State *L )
{
  int numret = 0;
  LONG retval;


  retval = 
    GetMenuCheckMarkDimensions(
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_ModifyMenuW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMENU p1;
  UINT p2;
  UINT p3;
  UINT_PTR p4;
  LPCWSTR p5;

  p1 = (HMENU)lua_tohandle(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (UINT_PTR)lua_tohandle(L, 4);
  p5 = (LPCWSTR)lua_tostring(L, 5);

  retval = 
    ModifyMenuW(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_MoveWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  int p2;
  int p3;
  int p4;
  int p5;
  BOOL p6;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);

  retval = 
    MoveWindow(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_SetWindowPos( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  HWND p2;
  int p3;
  int p4;
  int p5;
  int p6;
  UINT p7;

  p1 = lua_toWindow(L, 1);
  p2 = lua_toWindow(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);
  p7 = (UINT)lua_tonumber(L, 7);

  retval = 
    SetWindowPos(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_GetWindowPlacement( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  WINDOWPLACEMENT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (WINDOWPLACEMENT*)luacwrap_checktype(L, 2, &regType_WINDOWPLACEMENT.hdr);

  retval = 
    GetWindowPlacement(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_SetWindowPlacement( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  WINDOWPLACEMENT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (WINDOWPLACEMENT*)luacwrap_checktype(L, 2, &regType_WINDOWPLACEMENT.hdr);

  retval = 
    SetWindowPlacement(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_BringWindowToTop( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    BringWindowToTop(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetForegroundWindow( lua_State *L )
{
  int numret = 0;
  HWND retval;


  retval = 
    GetForegroundWindow(
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_SetForegroundWindow( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    SetForegroundWindow(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_SetFocus( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    SetFocus(
      p1
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_GetFocus( lua_State *L )
{
  int numret = 0;
  HWND retval;


  retval = 
    GetFocus(
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_GetMessageW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  MSG* p1;
  HWND p2;
  UINT p3;
  UINT p4;

  p1 = (MSG*)luacwrap_checktype(L, 1, &regType_MSG.hdr);
  p2 = lua_toWindow(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);

  retval = 
    GetMessageW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_PostMessageW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  UINT p2;
  WPARAM p3;
  LPARAM p4;

  p1 = lua_toWindow(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (WPARAM)lua_tolwparam(L, 3);
  p4 = (LPARAM)lua_tolwparam(L, 4);

  retval = 
    PostMessageW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_PostThreadMessageW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  DWORD p1;
  UINT p2;
  WPARAM p3;
  LPARAM p4;

  p1 = (DWORD)lua_tonumber(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (WPARAM)lua_tolwparam(L, 3);
  p4 = (LPARAM)lua_tolwparam(L, 4);

  retval = 
    PostThreadMessageW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_SendMessageW( lua_State *L )
{
  int numret = 0;
  LRESULT retval;
  HWND p1;
  UINT p2;
  WPARAM p3;
  LPARAM p4;

  p1 = lua_toWindow(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (WPARAM)lua_tolwparam(L, 3);
  p4 = (LPARAM)lua_tolwparam(L, 4);

  retval = 
    SendMessageW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_PeekMessageW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  MSG* p1;
  HWND p2;
  UINT p3;
  UINT p4;
  UINT p5;

  p1 = (MSG*)luacwrap_checktype(L, 1, &regType_MSG.hdr);
  p2 = lua_toWindow(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);
  p5 = (UINT)lua_tonumber(L, 5);

  retval = 
    PeekMessageW(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_WaitMessage( lua_State *L )
{
  int numret = 0;
  BOOL retval;


  retval = 
    WaitMessage(
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_WaitForInputIdle( lua_State *L )
{
  int numret = 0;
  DWORD retval;
  HANDLE p1;
  DWORD p2;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    WaitForInputIdle(
      p1,
      p2
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#endif
int winapi_TranslateMessage( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  MSG* p1;

  p1 = (MSG*)luacwrap_checktype(L, 1, &regType_MSG.hdr);

  retval = 
    TranslateMessage(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_DispatchMessageW( lua_State *L )
{
  int numret = 0;
  LRESULT retval;
  MSG* p1;

  p1 = (MSG*)luacwrap_checktype(L, 1, &regType_MSG.hdr);

  retval = 
    DispatchMessageW(
      p1
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_IsDialogMessageW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  MSG* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (MSG*)luacwrap_checktype(L, 2, &regType_MSG.hdr);

  retval = 
    IsDialogMessageW(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_CreateAcceleratorTableW( lua_State *L )
{
  int numret = 0;
  HACCEL retval;
  ACCEL* p1;
  int p2;

  p1 = (ACCEL*)luacwrap_checktype(L, 1, &regType_ACCEL.hdr);
  p2 = lua_tointeger(L, 2);

  retval = 
    CreateAcceleratorTableW(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_TranslateAcceleratorW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  HACCEL p2;
  MSG* p3;

  p1 = lua_toWindow(L, 1);
  p2 = (HACCEL)lua_tohandle(L, 2);
  p3 = (MSG*)luacwrap_checktype(L, 3, &regType_MSG.hdr);

  retval = 
    TranslateAcceleratorW(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_DefWindowProcW( lua_State *L )
{
  int numret = 0;
  LRESULT retval;
  HWND p1;
  UINT p2;
  WPARAM p3;
  LPARAM p4;

  p1 = lua_toWindow(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);
  p3 = (WPARAM)lua_tolwparam(L, 3);
  p4 = (LPARAM)lua_tolwparam(L, 4);

  retval = 
    DefWindowProcW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_CallWindowProcW( lua_State *L )
{
  int numret = 0;
  LRESULT retval;
  WNDPROC p1;
  HWND p2;
  UINT p3;
  WPARAM p4;
  LPARAM p5;

  p1 = (WNDPROC)lua_tohandle(L, 1);
  p2 = lua_toWindow(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (WPARAM)lua_tolwparam(L, 4);
  p5 = (LPARAM)lua_tolwparam(L, 5);

  retval = 
    CallWindowProcW(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_GetWindowLongW( lua_State *L )
{
  int numret = 0;
  LONG retval;
  HWND p1;
  int p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    GetWindowLongW(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_SetWindowLongW( lua_State *L )
{
  int numret = 0;
  LONG retval;
  HWND p1;
  int p2;
  UINT_PTR p3;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = (UINT_PTR)lua_tohandle(L, 3);

  retval = 
    SetWindowLongW(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_PostQuitMessage( lua_State *L )
{
  int numret = 0;
  int p1;

  p1 = lua_tointeger(L, 1);

    PostQuitMessage(
      p1
    );

  return numret;
}

int winapi_GetDC( lua_State *L )
{
  int numret = 0;
  HDC retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    GetDC(
      p1
    );

  // marshal retval  
  numret += lua_pushDC(L, retval);

  return numret;
}

int winapi_GetDCEx( lua_State *L )
{
  int numret = 0;
  HDC retval;
  HWND p1;
  HRGN p2;
  DWORD p3;

  p1 = lua_toWindow(L, 1);
  p2 = lua_toRegion(L, 2);
  p3 = (DWORD)lua_tonumber(L, 3);

  retval = 
    GetDCEx(
      p1,
      p2,
      p3
    );

  // marshal retval  
  numret += lua_pushDC(L, retval);

  return numret;
}

int winapi_GetWindowDC( lua_State *L )
{
  int numret = 0;
  HDC retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    GetWindowDC(
      p1
    );

  // marshal retval  
  numret += lua_pushDC(L, retval);

  return numret;
}

int winapi_ReleaseDC( lua_State *L )
{
  int numret = 0;
  int retval;
  HWND p1;
  HDC p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_toDC(L, 2);

  retval = 
    ReleaseDC(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_BeginPaint( lua_State *L )
{
  int numret = 0;
  HDC retval;
  HWND p1;
  PAINTSTRUCT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (PAINTSTRUCT*)luacwrap_checktype(L, 2, &regType_PAINTSTRUCT.hdr);

  retval = 
    BeginPaint(
      p1,
      p2
    );

  // marshal retval  
  numret += lua_pushDC(L, retval);

  return numret;
}

int winapi_EndPaint( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  PAINTSTRUCT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (PAINTSTRUCT*)luacwrap_checktype(L, 2, &regType_PAINTSTRUCT.hdr);

  retval = 
    EndPaint(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_InvalidateRect( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  RECT* p2 = 0;
  BOOL p3;

  p1 = lua_toWindow(L, 1);
  if (!lua_isnil(L, 2))
  {
    p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);
  }
  p3 = lua_tointeger(L, 3);

  retval = 
    InvalidateRect(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ValidateRect( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  RECT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);

  retval = 
    ValidateRect(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetClientRect( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  RECT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);

  retval = 
    GetClientRect(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetWindowRect( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  RECT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);

  retval = 
    GetWindowRect(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ClientToScreen( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  POINT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (POINT*)luacwrap_checktype(L, 2, &regType_POINT.hdr);

  retval = 
    ClientToScreen(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ScreenToClient( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  POINT* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (POINT*)luacwrap_checktype(L, 2, &regType_POINT.hdr);

  retval = 
    ScreenToClient(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_MapWindowPoints( lua_State *L )
{
  int numret = 0;
  int retval;
  HWND p1;
  HWND p2;
  POINT* p3;
  UINT p4;

  p1 = lua_toWindow(L, 1);
  p2 = lua_toWindow(L, 2);
  p3 = (POINT*)luacwrap_checktype(L, 3, &regType_POINT.hdr);
  p4 = (UINT)lua_tonumber(L, 4);

  retval = 
    MapWindowPoints(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetCursorPos( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  POINT* p1;

  p1 = (POINT*)luacwrap_checktype(L, 1, &regType_POINT.hdr);

  retval = 
    GetCursorPos(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetCapture( lua_State *L )
{
  int numret = 0;
  HWND retval;


  retval = 
    GetCapture(
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_SetCapture( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    SetCapture(
      p1
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_ReleaseCapture( lua_State *L )
{
  int numret = 0;
  BOOL retval;


  retval = 
    ReleaseCapture(
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_AdjustWindowRect( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  RECT* p1;
  DWORD p2;
  BOOL p3;

  p1 = (RECT*)luacwrap_checktype(L, 1, &regType_RECT.hdr);
  p2 = (DWORD)lua_tonumber(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    AdjustWindowRect(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_AdjustWindowRectEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  RECT* p1;
  DWORD p2;
  BOOL p3;
  DWORD p4;

  p1 = (RECT*)luacwrap_checktype(L, 1, &regType_RECT.hdr);
  p2 = (DWORD)lua_tonumber(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (DWORD)lua_tonumber(L, 4);

  retval = 
    AdjustWindowRectEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_MessageBoxW( lua_State *L )
{
  int numret = 0;
  int retval;
  HWND p1 = 0;
  LPCWSTR p2;
  LPCWSTR p3;
  UINT p4;

  if (!lua_isnil(L, 1))
  {
    p1 = lua_toWindow(L, 1);
  }
  p2 = (LPCWSTR)lua_tostring(L, 2);
  p3 = (LPCWSTR)lua_tostring(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);

  retval = 
    MessageBoxW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_MessageBoxExW( lua_State *L )
{
  int numret = 0;
  int retval;
  HWND p1 = 0;
  LPCWSTR p2;
  LPCWSTR p3;
  UINT p4;
  WORD p5;

  if (!lua_isnil(L, 1))
  {
    p1 = lua_toWindow(L, 1);
  }
  p2 = (LPCWSTR)lua_tostring(L, 2);
  p3 = (LPCWSTR)lua_tostring(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);
  p5 = lua_tointeger(L, 5);

  retval = 
    MessageBoxExW(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_MessageBeep( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  UINT p1;

  p1 = (UINT)lua_tonumber(L, 1);

  retval = 
    MessageBeep(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_Beep( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  DWORD p1;
  DWORD p2;

  p1 = (DWORD)lua_tonumber(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    Beep(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_GetTopWindow( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    GetTopWindow(
      p1
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_GetLastActivePopup( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    GetLastActivePopup(
      p1
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

#endif
int winapi_GetWindow( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;
  UINT p2;

  p1 = lua_toWindow(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);

  retval = 
    GetWindow(
      p1,
      p2
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

int winapi_RegisterHotKey( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  int p2;
  UINT p3;
  UINT p4;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);

  retval = 
    RegisterHotKey(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_UnregisterHotKey( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  int p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    UnregisterHotKey(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (defined(UNDER_CE))
int winapi_AllKeys( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  BOOL p1;

  p1 = lua_tointeger(L, 1);

  retval = 
    AllKeys(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_GetSysColor( lua_State *L )
{
  int numret = 0;
  DWORD retval;
  int p1;

  p1 = lua_tointeger(L, 1);

  retval = 
    GetSysColor(
      p1
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_GetSysColorBrush( lua_State *L )
{
  int numret = 0;
  HBRUSH retval;
  int p1;

  p1 = lua_tointeger(L, 1);

  retval = 
    GetSysColorBrush(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_DrawFocusRect( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  RECT* p2;

  p1 = lua_toDC(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);

  retval = 
    DrawFocusRect(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_DrawEdge( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  RECT* p2;
  UINT p3;
  UINT p4;

  p1 = lua_toDC(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);

  retval = 
    DrawEdge(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_DrawFrameControl( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  RECT* p2;
  UINT p3;
  UINT p4;

  p1 = lua_toDC(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);

  retval = 
    DrawFrameControl(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_DrawCaption( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  HDC p2;
  RECT* p3;
  UINT p4;

  p1 = lua_toWindow(L, 1);
  p2 = lua_toDC(L, 2);
  p3 = (RECT*)luacwrap_checktype(L, 3, &regType_RECT.hdr);
  p4 = (UINT)lua_tonumber(L, 4);

  retval = 
    DrawCaption(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_DrawAnimatedRects( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  int p2;
  RECT* p3;
  RECT* p4;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = (RECT*)luacwrap_checktype(L, 3, &regType_RECT.hdr);
  p4 = (RECT*)luacwrap_checktype(L, 4, &regType_RECT.hdr);

  retval = 
    DrawAnimatedRects(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_DrawTextW( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;
  LPCWSTR p2;
  int p3;
  RECT* p4;
  UINT p5;

  p1 = lua_toDC(L, 1);
  p2 = (LPCWSTR)lua_tostring(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (RECT*)luacwrap_checktype(L, 4, &regType_RECT.hdr);
  p5 = (UINT)lua_tonumber(L, 5);

  retval = 
    DrawTextW(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_FillRect( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;
  RECT* p2;
  HBRUSH p3;

  p1 = lua_toDC(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);
  p3 = (HBRUSH)lua_tohandle(L, 3);

  retval = 
    FillRect(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_FrameRect( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;
  RECT* p2;
  HBRUSH p3;

  p1 = lua_toDC(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);
  p3 = (HBRUSH)lua_tohandle(L, 3);

  retval = 
    FrameRect(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_InvertRect( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  RECT* p2;

  p1 = lua_toDC(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);

  retval = 
    InvertRect(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_LoadImageW( lua_State *L )
{
  int numret = 0;
  HANDLE retval;
  HINSTANCE p1;
  LPCWSTR p2;
  UINT p3;
  int p4;
  int p5;
  UINT p6;

  p1 = (HINSTANCE)lua_tohandle(L, 1);
  p2 = (LPCWSTR)lua_toresourceref(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = (UINT)lua_tonumber(L, 6);

  retval = 
    LoadImageW(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_LoadCursorW( lua_State *L )
{
  int numret = 0;
  HCURSOR retval;
  HINSTANCE p1;
  LPCWSTR p2;

  p1 = (HINSTANCE)lua_tohandle(L, 1);
  p2 = (LPCWSTR)lua_toresourceref(L, 2);

  retval = 
    LoadCursorW(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_SetCursor( lua_State *L )
{
  int numret = 0;
  HCURSOR retval;
  HCURSOR p1;

  p1 = (HCURSOR)lua_tohandle(L, 1);

  retval = 
    SetCursor(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_DeleteObject( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HGDIOBJ p1;

  p1 = (HGDIOBJ)lua_tohandle(L, 1);

  retval = 
    DeleteObject(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetObjectW( lua_State *L )
{
  int numret = 0;
  int retval;
  HGDIOBJ p1;
  int p2;
  LPVOID p3;

  p1 = (HGDIOBJ)lua_tohandle(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = (LPVOID)lua_touserdata(L, 3);

  retval = 
    GetObjectW(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetObjectType( lua_State *L )
{
  int numret = 0;
  DWORD retval;
  HGDIOBJ p1;

  p1 = (HGDIOBJ)lua_tohandle(L, 1);

  retval = 
    GetObjectType(
      p1
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_GetStockObject( lua_State *L )
{
  int numret = 0;
  HGDIOBJ retval;
  int p1;

  p1 = lua_tointeger(L, 1);

  retval = 
    GetStockObject(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_SelectObject( lua_State *L )
{
  int numret = 0;
  HGDIOBJ retval;
  HDC p1;
  HGDIOBJ p2;

  p1 = lua_toDC(L, 1);
  p2 = (HGDIOBJ)lua_tohandle(L, 2);

  retval = 
    SelectObject(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_CreateCompatibleDC( lua_State *L )
{
  int numret = 0;
  HDC retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    CreateCompatibleDC(
      p1
    );

  // marshal retval  
  numret += lua_pushDC(L, retval);

  return numret;
}

int winapi_DeleteDC( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    DeleteDC(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ExcludeClipRect( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);

  retval = 
    ExcludeClipRect(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_IntersectClipRect( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);

  retval = 
    IntersectClipRect(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetCurrentObject( lua_State *L )
{
  int numret = 0;
  HGDIOBJ retval;
  HDC p1;
  UINT p2;

  p1 = lua_toDC(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);

  retval = 
    GetCurrentObject(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_FrameRgn( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  HRGN p2;
  HBRUSH p3;
  int p4;
  int p5;

  p1 = lua_toDC(L, 1);
  p2 = lua_toRegion(L, 2);
  p3 = (HBRUSH)lua_tohandle(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);

  retval = 
    FrameRgn(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_InvertRgn( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  HRGN p2;

  p1 = lua_toDC(L, 1);
  p2 = lua_toRegion(L, 2);

  retval = 
    InvertRgn(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_PaintRgn( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  HRGN p2;

  p1 = lua_toDC(L, 1);
  p2 = lua_toRegion(L, 2);

  retval = 
    PaintRgn(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_SetBkColor( lua_State *L )
{
  int numret = 0;
  COLORREF retval;
  HDC p1;
  COLORREF p2;

  p1 = lua_toDC(L, 1);
  p2 = (COLORREF)lua_tonumber(L, 2);

  retval = 
    SetBkColor(
      p1,
      p2
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_GetBkColor( lua_State *L )
{
  int numret = 0;
  COLORREF retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    GetBkColor(
      p1
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_SetDCBrushColor( lua_State *L )
{
  int numret = 0;
  COLORREF retval;
  HDC p1;
  COLORREF p2;

  p1 = lua_toDC(L, 1);
  p2 = (COLORREF)lua_tonumber(L, 2);

  retval = 
    SetDCBrushColor(
      p1,
      p2
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_GetDCBrushColor( lua_State *L )
{
  int numret = 0;
  COLORREF retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    GetDCBrushColor(
      p1
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_SetDCPenColor( lua_State *L )
{
  int numret = 0;
  COLORREF retval;
  HDC p1;
  COLORREF p2;

  p1 = lua_toDC(L, 1);
  p2 = (COLORREF)lua_tonumber(L, 2);

  retval = 
    SetDCPenColor(
      p1,
      p2
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_GetDCPenColor( lua_State *L )
{
  int numret = 0;
  COLORREF retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    GetDCPenColor(
      p1
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#endif
int winapi_SetBkMode( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;
  int p2;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    SetBkMode(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetBkMode( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    GetBkMode(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_SetMapMode( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;
  int p2;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    SetMapMode(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_SetPolyFillMode( lua_State *L )
{
  int numret = 0;
  int retval;
  HDC p1;
  int p2;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    SetPolyFillMode(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_SetTextColor( lua_State *L )
{
  int numret = 0;
  COLORREF retval;
  HDC p1;
  COLORREF p2;

  p1 = lua_toDC(L, 1);
  p2 = (COLORREF)lua_tonumber(L, 2);

  retval = 
    SetTextColor(
      p1,
      p2
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

int winapi_SetTextAlign( lua_State *L )
{
  int numret = 0;
  UINT retval;
  HDC p1;
  UINT p2;

  p1 = lua_toDC(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);

  retval = 
    SetTextAlign(
      p1,
      p2
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_SetTextJustification( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    SetTextJustification(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_PtVisible( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    PtVisible(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_RectVisible( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  RECT* p2;

  p1 = lua_toDC(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);

  retval = 
    RectVisible(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_SetViewportExtEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  SIZE* p4;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (SIZE*)luacwrap_checktype(L, 4, &regType_SIZE.hdr);

  retval = 
    SetViewportExtEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_SetViewportOrgEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  POINT* p4;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (POINT*)luacwrap_checktype(L, 4, &regType_POINT.hdr);

  retval = 
    SetViewportOrgEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_SetWindowExtEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  SIZE* p4;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (SIZE*)luacwrap_checktype(L, 4, &regType_SIZE.hdr);

  retval = 
    SetWindowExtEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_SetWindowOrgEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  POINT* p4;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (POINT*)luacwrap_checktype(L, 4, &regType_POINT.hdr);

  retval = 
    SetWindowOrgEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_OffsetViewportOrgEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  POINT* p4;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (POINT*)luacwrap_checktype(L, 4, &regType_POINT.hdr);

  retval = 
    OffsetViewportOrgEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_OffsetWindowOrgEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  POINT* p4;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (POINT*)luacwrap_checktype(L, 4, &regType_POINT.hdr);

  retval = 
    OffsetWindowOrgEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_ScaleViewportExtEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  SIZE* p6;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = (SIZE*)luacwrap_checktype(L, 6, &regType_SIZE.hdr);

  retval = 
    ScaleViewportExtEx(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_ScaleWindowExtEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  SIZE* p6;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = (SIZE*)luacwrap_checktype(L, 6, &regType_SIZE.hdr);

  retval = 
    ScaleWindowExtEx(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_CreatePen( lua_State *L )
{
  int numret = 0;
  HPEN retval;
  int p1;
  int p2;
  COLORREF p3;

  p1 = lua_tointeger(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = (COLORREF)lua_tonumber(L, 3);

  retval = 
    CreatePen(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_CreatePenIndirect( lua_State *L )
{
  int numret = 0;
  HPEN retval;
  LOGPEN* p1;

  p1 = (LOGPEN*)luacwrap_checktype(L, 1, &regType_LOGPEN.hdr);

  retval = 
    CreatePenIndirect(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_CreatePatternBrush( lua_State *L )
{
  int numret = 0;
  HBRUSH retval;
  HBITMAP p1;

  p1 = (HBITMAP)lua_tohandle(L, 1);

  retval = 
    CreatePatternBrush(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

int winapi_CreateSolidBrush( lua_State *L )
{
  int numret = 0;
  HBRUSH retval;
  COLORREF p1;

  p1 = (COLORREF)lua_tonumber(L, 1);

  retval = 
    CreateSolidBrush(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_CreateHatchBrush( lua_State *L )
{
  int numret = 0;
  HBRUSH retval;
  int p1;
  COLORREF p2;

  p1 = lua_tointeger(L, 1);
  p2 = (COLORREF)lua_tonumber(L, 2);

  retval = 
    CreateHatchBrush(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif
int winapi_CreateFontIndirectW( lua_State *L )
{
  int numret = 0;
  HFONT retval;
  LOGFONTW* p1;

  p1 = (LOGFONTW*)luacwrap_checktype(L, 1, &regType_LOGFONTW.hdr);

  retval = 
    CreateFontIndirectW(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_CreateFontW( lua_State *L )
{
  int numret = 0;
  HFONT retval;
  int p1;
  int p2;
  int p3;
  int p4;
  int p5;
  DWORD p6;
  DWORD p7;
  DWORD p8;
  DWORD p9;
  DWORD p10;
  DWORD p11;
  DWORD p12;
  DWORD p13;
  LPCWSTR p14;

  p1 = lua_tointeger(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = (DWORD)lua_tonumber(L, 6);
  p7 = (DWORD)lua_tonumber(L, 7);
  p8 = (DWORD)lua_tonumber(L, 8);
  p9 = (DWORD)lua_tonumber(L, 9);
  p10 = (DWORD)lua_tonumber(L, 10);
  p11 = (DWORD)lua_tonumber(L, 11);
  p12 = (DWORD)lua_tonumber(L, 12);
  p13 = (DWORD)lua_tonumber(L, 13);
  p14 = (LPCWSTR)lua_tostring(L, 14);

  retval = 
    CreateFontW(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9,
      p10,
      p11,
      p12,
      p13,
      p14
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif
int winapi_GetTextExtentExPointW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  LPCWSTR p2;
  int p3;
  int p4;
  LPINT p5;
  LPINT p6;
  SIZE* p7;

  p1 = lua_toDC(L, 1);
  p2 = (LPCWSTR)lua_tostring(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = (LPINT)lua_touserdata(L, 5);
  p6 = (LPINT)lua_touserdata(L, 6);
  p7 = (SIZE*)luacwrap_checktype(L, 7, &regType_SIZE.hdr);

  retval = 
    GetTextExtentExPointW(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetTextExtentPoint32W( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  LPCWSTR p2;
  int p3;
  SIZE* p4;

  p1 = lua_toDC(L, 1);
  p2 = (LPCWSTR)lua_tostring(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (SIZE*)luacwrap_checktype(L, 4, &regType_SIZE.hdr);

  retval = 
    GetTextExtentPoint32W(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_CreateRectRgn( lua_State *L )
{
  int numret = 0;
  HRGN retval;
  int p1;
  int p2;
  int p3;
  int p4;

  p1 = lua_tointeger(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);

  retval = 
    CreateRectRgn(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  numret += lua_pushRegion(L, retval);

  return numret;
}

int winapi_CreateRectRgnIndirect( lua_State *L )
{
  int numret = 0;
  HRGN retval;
  RECT* p1;

  p1 = (RECT*)luacwrap_checktype(L, 1, &regType_RECT.hdr);

  retval = 
    CreateRectRgnIndirect(
      p1
    );

  // marshal retval  
  numret += lua_pushRegion(L, retval);

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_CreateRoundRectRgn( lua_State *L )
{
  int numret = 0;
  HRGN retval;
  int p1;
  int p2;
  int p3;
  int p4;
  int p5;
  int p6;

  p1 = lua_tointeger(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);

  retval = 
    CreateRoundRectRgn(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  numret += lua_pushRegion(L, retval);

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_CreateEllipticRgn( lua_State *L )
{
  int numret = 0;
  HRGN retval;
  int p1;
  int p2;
  int p3;
  int p4;

  p1 = lua_tointeger(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);

  retval = 
    CreateEllipticRgn(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  numret += lua_pushRegion(L, retval);

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_CreateEllipticRgnIndirect( lua_State *L )
{
  int numret = 0;
  HRGN retval;
  RECT* p1;

  p1 = (RECT*)luacwrap_checktype(L, 1, &regType_RECT.hdr);

  retval = 
    CreateEllipticRgnIndirect(
      p1
    );

  // marshal retval  
  numret += lua_pushRegion(L, retval);

  return numret;
}

#endif
int winapi_EqualRgn( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HRGN p1;
  HRGN p2;

  p1 = lua_toRegion(L, 1);
  p2 = lua_toRegion(L, 2);

  retval = 
    EqualRgn(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_CombineRgn( lua_State *L )
{
  int numret = 0;
  int retval;
  HRGN p1;
  HRGN p2;
  HRGN p3;
  int p4;

  p1 = lua_toRegion(L, 1);
  p2 = lua_toRegion(L, 2);
  p3 = lua_toRegion(L, 3);
  p4 = lua_tointeger(L, 4);

  retval = 
    CombineRgn(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_OffsetRgn( lua_State *L )
{
  int numret = 0;
  int retval;
  HRGN p1;
  int p2;
  int p3;

  p1 = lua_toRegion(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    OffsetRgn(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_SetRectRgn( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HRGN p1;
  int p2;
  int p3;
  int p4;
  int p5;

  p1 = lua_toRegion(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);

  retval = 
    SetRectRgn(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_PtInRegion( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HRGN p1;
  int p2;
  int p3;

  p1 = lua_toRegion(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    PtInRegion(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_RectInRegion( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HRGN p1;
  RECT* p2;

  p1 = lua_toRegion(L, 1);
  p2 = (RECT*)luacwrap_checktype(L, 2, &regType_RECT.hdr);

  retval = 
    RectInRegion(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_BeginPath( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    BeginPath(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_CloseFigure( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    CloseFigure(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_EndPath( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    EndPath(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_FillPath( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    FillPath(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_FlattenPath( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    FlattenPath(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_PathToRegion( lua_State *L )
{
  int numret = 0;
  HRGN retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    PathToRegion(
      p1
    );

  // marshal retval  
  numret += lua_pushRegion(L, retval);

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_StrokeAndFillPath( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    StrokeAndFillPath(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_StrokePath( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    StrokePath(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_WidenPath( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    WidenPath(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_Arc( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  int p6;
  int p7;
  int p8;
  int p9;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);
  p7 = lua_tointeger(L, 7);
  p8 = lua_tointeger(L, 8);
  p9 = lua_tointeger(L, 9);

  retval = 
    Arc(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_ArcTo( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  int p6;
  int p7;
  int p8;
  int p9;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);
  p7 = lua_tointeger(L, 7);
  p8 = lua_tointeger(L, 8);
  p9 = lua_tointeger(L, 9);

  retval = 
    ArcTo(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_Chord( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  int p6;
  int p7;
  int p8;
  int p9;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);
  p7 = lua_tointeger(L, 7);
  p8 = lua_tointeger(L, 8);
  p9 = lua_tointeger(L, 9);

  retval = 
    Chord(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_LineTo( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    LineTo(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_MoveToEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  POINT* p4 = 0;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  if (!lua_isnil(L, 4))
  {
    p4 = (POINT*)luacwrap_checktype(L, 4, &regType_POINT.hdr);
  }

  retval = 
    MoveToEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_Ellipse( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);

  retval = 
    Ellipse(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_Pie( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  int p6;
  int p7;
  int p8;
  int p9;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);
  p7 = lua_tointeger(L, 7);
  p8 = lua_tointeger(L, 8);
  p9 = lua_tointeger(L, 9);

  retval = 
    Pie(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_Rectangle( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);

  retval = 
    Rectangle(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_RoundRect( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  int p6;
  int p7;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);
  p7 = lua_tointeger(L, 7);

  retval = 
    RoundRect(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_ExtFloodFill( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  COLORREF p4;
  UINT p5;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (COLORREF)lua_tonumber(L, 4);
  p5 = (UINT)lua_tonumber(L, 5);

  retval = 
    ExtFloodFill(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_FillRgn( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  HRGN p2;
  HBRUSH p3;

  p1 = lua_toDC(L, 1);
  p2 = lua_toRegion(L, 2);
  p3 = (HBRUSH)lua_tohandle(L, 3);

  retval = 
    FillRgn(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_FloodFill( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  COLORREF p4;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (COLORREF)lua_tonumber(L, 4);

  retval = 
    FloodFill(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_BitBlt( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  HDC p6;
  int p7;
  int p8;
  DWORD p9;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_toDC(L, 6);
  p7 = lua_tointeger(L, 7);
  p8 = lua_tointeger(L, 8);
  p9 = (DWORD)lua_tonumber(L, 9);

  retval = 
    BitBlt(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_PatBlt( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  DWORD p6;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = (DWORD)lua_tonumber(L, 6);

  retval = 
    PatBlt(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_StretchBlt( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  HDC p6;
  int p7;
  int p8;
  int p9;
  int p10;
  DWORD p11;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_toDC(L, 6);
  p7 = lua_tointeger(L, 7);
  p8 = lua_tointeger(L, 8);
  p9 = lua_tointeger(L, 9);
  p10 = lua_tointeger(L, 10);
  p11 = (DWORD)lua_tonumber(L, 11);

  retval = 
    StretchBlt(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9,
      p10,
      p11
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_TransparentBlt( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;
  HDC p6;
  int p7;
  int p8;
  int p9;
  int p10;
  UINT p11;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_toDC(L, 6);
  p7 = lua_tointeger(L, 7);
  p8 = lua_tointeger(L, 8);
  p9 = lua_tointeger(L, 9);
  p10 = lua_tointeger(L, 10);
  p11 = (UINT)lua_tonumber(L, 11);

  retval = 
    TransparentBlt(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      p8,
      p9,
      p10,
      p11
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (!defined(UNDER_CE))
int winapi_TextOutW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  LPCWSTR p4;
  int p5;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (LPCWSTR)lua_tostring(L, 4);
  p5 = lua_tointeger(L, 5);

  retval = 
    TextOutW(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_ExtTextOutW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  int p3;
  UINT p4;
  RECT* p5;
  LPCWSTR p6;
  UINT p7;
  INT p8;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);
  p5 = (RECT*)luacwrap_checktype(L, 5, &regType_RECT.hdr);
  p6 = (LPCWSTR)lua_tostring(L, 6);
  p7 = (UINT)lua_tonumber(L, 7);
  p8 = lua_tointeger(L, 8);

  retval = 
    ExtTextOutW(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7,
      &p8
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#if (defined(USE_OPENGL))
int winapi_wglCopyContext( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HGLRC p1;
  HGLRC p2;
  UINT p3;

  p1 = (HGLRC)lua_tohandle(L, 1);
  p2 = (HGLRC)lua_tohandle(L, 2);
  p3 = (UINT)lua_tonumber(L, 3);

  retval = 
    wglCopyContext(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglCreateContext( lua_State *L )
{
  int numret = 0;
  HGLRC retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    wglCreateContext(
      p1
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglCreateLayerContext( lua_State *L )
{
  int numret = 0;
  HGLRC retval;
  HDC p1;
  int p2;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    wglCreateLayerContext(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglDeleteContext( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HGLRC p1;

  p1 = (HGLRC)lua_tohandle(L, 1);

  retval = 
    wglDeleteContext(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglGetCurrentContext( lua_State *L )
{
  int numret = 0;
  HGLRC retval;


  retval = 
    wglGetCurrentContext(
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglGetCurrentDC( lua_State *L )
{
  int numret = 0;
  HDC retval;


  retval = 
    wglGetCurrentDC(
    );

  // marshal retval  
  numret += lua_pushDC(L, retval);

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglMakeCurrent( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  HGLRC p2;

  p1 = lua_toDC(L, 1);
  p2 = (HGLRC)lua_tohandle(L, 2);

  retval = 
    wglMakeCurrent(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglShareLists( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HGLRC p1;
  HGLRC p2;

  p1 = (HGLRC)lua_tohandle(L, 1);
  p2 = (HGLRC)lua_tohandle(L, 2);

  retval = 
    wglShareLists(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglUseFontBitmapsA( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  DWORD p2;
  DWORD p3;
  DWORD p4;

  p1 = lua_toDC(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);
  p3 = (DWORD)lua_tonumber(L, 3);
  p4 = (DWORD)lua_tonumber(L, 4);

  retval = 
    wglUseFontBitmapsA(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglUseFontBitmapsW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  DWORD p2;
  DWORD p3;
  DWORD p4;

  p1 = lua_toDC(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);
  p3 = (DWORD)lua_tonumber(L, 3);
  p4 = (DWORD)lua_tonumber(L, 4);

  retval = 
    wglUseFontBitmapsW(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_SwapBuffers( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;

  p1 = lua_toDC(L, 1);

  retval = 
    SwapBuffers(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglRealizeLayerPalette( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  int p2;
  BOOL p3;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    wglRealizeLayerPalette(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_OPENGL))
int winapi_wglSwapLayerBuffers( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HDC p1;
  UINT p2;

  p1 = lua_toDC(L, 1);
  p2 = (UINT)lua_tonumber(L, 2);

  retval = 
    wglSwapLayerBuffers(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_InitCommonControls( lua_State *L )
{
  int numret = 0;


    InitCommonControls(
    );

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_ImageList_LoadImageW( lua_State *L )
{
  int numret = 0;
  HIMAGELIST retval;
  HINSTANCE p1 = 0;
  LPCWSTR p2;
  int p3;
  int p4;
  COLORREF p5;
  UINT p6;
  UINT p7;

  if (!lua_isnil(L, 1))
  {
    p1 = (HINSTANCE)lua_tohandle(L, 1);
  }
  p2 = (LPCWSTR)lua_toresourceref(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = (COLORREF)lua_tonumber(L, 5);
  p6 = (UINT)lua_tonumber(L, 6);
  p7 = (UINT)lua_tonumber(L, 7);

  retval = 
    ImageList_LoadImageW(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6,
      p7
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif
int winapi_ImageList_AddMasked( lua_State *L )
{
  int numret = 0;
  int retval;
  HIMAGELIST p1;
  HBITMAP p2;
  COLORREF p3;

  p1 = (HIMAGELIST)lua_tohandle(L, 1);
  p2 = (HBITMAP)lua_tohandle(L, 2);
  p3 = (COLORREF)lua_tonumber(L, 3);

  retval = 
    ImageList_AddMasked(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetOpenFileNameW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  OPENFILENAMEW* p1;

  p1 = (OPENFILENAMEW*)luacwrap_checktype(L, 1, &regType_OPENFILENAMEW.hdr);

  retval = 
    GetOpenFileNameW(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_GetSaveFileNameW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  OPENFILENAMEW* p1;

  p1 = (OPENFILENAMEW*)luacwrap_checktype(L, 1, &regType_OPENFILENAMEW.hdr);

  retval = 
    GetSaveFileNameW(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_ChooseColor( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  CHOOSECOLOR* p1;

  p1 = (CHOOSECOLOR*)luacwrap_checktype(L, 1, &regType_CHOOSECOLOR.hdr);

  retval = 
    ChooseColor(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

int winapi_CommDlgExtendedError( lua_State *L )
{
  int numret = 0;
  DWORD retval;


  retval = 
    CommDlgExtendedError(
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#if (!defined(UNDER_CE))
int winapi_PrintDlgW( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  PRINTDLGW* p1;

  p1 = (PRINTDLGW*)luacwrap_checktype(L, 1, &regType_PRINTDLGW.hdr);

  retval = 
    PrintDlgW(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
int winapi_DrawXorBar( lua_State *L )
{
  int numret = 0;
  HDC p1;
  int p2;
  int p3;
  int p4;
  int p5;

  p1 = lua_toDC(L, 1);
  p2 = lua_tointeger(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);

    DrawXorBar(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  return numret;
}

#if (defined(UNDER_CE))
int winapi_RequestPowerNotifications( lua_State *L )
{
  int numret = 0;
  HANDLE retval;
  HANDLE p1;
  DWORD p2;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    RequestPowerNotifications(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif
#if (defined(UNDER_CE))
int winapi_StopPowerNotifications( lua_State *L )
{
  int numret = 0;
  DWORD retval;
  HANDLE p1;

  p1 = (HANDLE)lua_tohandle(L, 1);

  retval = 
    StopPowerNotifications(
      p1
    );

  // marshal retval  
  lua_pushnumber(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_MSGQUEUE))
int winapi_CreateMsgQueue( lua_State *L )
{
  int numret = 0;
  HMSGQUEUE retval;
  LPCWSTR p1;
  MSGQUEUEOPTIONS* p2;

  p1 = (LPCWSTR)lua_tostring(L, 1);
  p2 = (MSGQUEUEOPTIONS*)luacwrap_checktype(L, 2, &regType_MSGQUEUEOPTIONS.hdr);

  retval = 
    CreateMsgQueue(
      p1,
      p2
    );

  // marshal retval  
  numret += lua_pushMsgQueue(L, retval);

  return numret;
}

#endif
#if (defined(USE_MSGQUEUE))
int winapi_OpenMsgQueue( lua_State *L )
{
  int numret = 0;
  HMSGQUEUE retval;
  HANDLE p1;
  HMSGQUEUE p2;
  MSGQUEUEOPTIONS* p3;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = lua_toMsgQueue(L, 2);
  p3 = (MSGQUEUEOPTIONS*)luacwrap_checktype(L, 3, &regType_MSGQUEUEOPTIONS.hdr);

  retval = 
    OpenMsgQueue(
      p1,
      p2,
      p3
    );

  // marshal retval  
  numret += lua_pushMsgQueue(L, retval);

  return numret;
}

#endif
#if (defined(USE_MSGQUEUE))
int winapi_ReadMsgQueue( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMSGQUEUE p1;
  PVOID p2;
  DWORD p3;
  DWORD p4;
  DWORD p5;
  DWORD p6;

  p1 = lua_toMsgQueue(L, 1);
  p2 = (PVOID)lua_touserdata(L, 2);
  p3 = (DWORD)lua_tonumber(L, 3);
  p4 = (DWORD)lua_tonumber(L, 4);
  p5 = (DWORD)lua_tonumber(L, 5);
  p6 = (DWORD)lua_tonumber(L, 6);

  retval = 
    ReadMsgQueue(
      p1,
      p2,
      p3,
      &p4,
      p5,
      &p6
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_MSGQUEUE))
int winapi_WriteMsgQueue( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMSGQUEUE p1;
  PVOID p2;
  DWORD p3;
  DWORD p4;
  DWORD p5;

  p1 = lua_toMsgQueue(L, 1);
  p2 = (PVOID)lua_touserdata(L, 2);
  p3 = (DWORD)lua_tonumber(L, 3);
  p4 = (DWORD)lua_tonumber(L, 4);
  p5 = (DWORD)lua_tonumber(L, 5);

  retval = 
    WriteMsgQueue(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_MSGQUEUE))
int winapi_GetMsgQueueInfo( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMSGQUEUE p1;
  MSGQUEUEINFO* p2;

  p1 = lua_toMsgQueue(L, 1);
  p2 = (MSGQUEUEINFO*)luacwrap_checktype(L, 2, &regType_MSGQUEUEINFO.hdr);

  retval = 
    GetMsgQueueInfo(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_MSGQUEUE))
int winapi_CloseMsgQueue( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HMSGQUEUE p1;

  p1 = lua_toMsgQueue(L, 1);

  retval = 
    CloseMsgQueue(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHInitExtraControls( lua_State *L )
{
  int numret = 0;
  BOOL retval;


  retval = 
    SHInitExtraControls(
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHInitDialog( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  SHINITDLGINFO* p1;

  p1 = (SHINITDLGINFO*)luacwrap_checktype(L, 1, &regType_SHINITDLGINFO.hdr);

  retval = 
    SHInitDialog(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHCreateMenuBar( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  SHMENUBARINFO* p1;

  p1 = (SHMENUBARINFO*)luacwrap_checktype(L, 1, &regType_SHMENUBARINFO.hdr);

  retval = 
    SHCreateMenuBar(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHFindMenuBar( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    SHFindMenuBar(
      p1
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHHandleWMActivate( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  WPARAM p2;
  LPARAM p3;
  SHACTIVATEINFO* p4;
  DWORD p5;

  p1 = lua_toWindow(L, 1);
  p2 = (WPARAM)lua_tolwparam(L, 2);
  p3 = (LPARAM)lua_tolwparam(L, 3);
  p4 = (SHACTIVATEINFO*)luacwrap_checktype(L, 4, &regType_SHACTIVATEINFO.hdr);
  p5 = (DWORD)lua_tonumber(L, 5);

  retval = 
    SHHandleWMActivate(
      p1,
      p2,
      p3,
      p4,
      p5
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHHandleWMSettingChange( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  WPARAM p2;
  LPARAM p3;
  SHACTIVATEINFO* p4;

  p1 = lua_toWindow(L, 1);
  p2 = (WPARAM)lua_tolwparam(L, 2);
  p3 = (LPARAM)lua_tolwparam(L, 3);
  p4 = (SHACTIVATEINFO*)luacwrap_checktype(L, 4, &regType_SHACTIVATEINFO.hdr);

  retval = 
    SHHandleWMSettingChange(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHFullScreen( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  DWORD p2;

  p1 = lua_toWindow(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    SHFullScreen(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHDoneButton( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  DWORD p2;

  p1 = lua_toWindow(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    SHDoneButton(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_AYGSHELL))
int winapi_SHSetAppKeyWndAssoc( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  BYTE p1;
  HWND p2;

  p1 = lua_tointeger(L, 1);
  p2 = lua_toWindow(L, 2);

  retval = 
    SHSetAppKeyWndAssoc(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_Create( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HINSTANCE p1;
  HWND p2;
  int p3;

  p1 = (HINSTANCE)lua_tohandle(L, 1);
  p2 = lua_toWindow(L, 2);
  p3 = lua_tointeger(L, 3);

  retval = 
    CommandBar_Create(
      p1,
      p2,
      p3
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_Show( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  BOOL p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    CommandBar_Show(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_AddBitmap( lua_State *L )
{
  int numret = 0;
  int retval;
  HWND p1;
  HINSTANCE p2;
  int p3;
  int p4;
  int p5;
  int p6;

  p1 = lua_toWindow(L, 1);
  p2 = (HINSTANCE)lua_tohandle(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);

  retval = 
    CommandBar_AddBitmap(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_InsertComboBox( lua_State *L )
{
  int numret = 0;
  HWND retval;
  HWND p1;
  HINSTANCE p2;
  int p3;
  UINT p4;
  WORD p5;
  WORD p6;

  p1 = lua_toWindow(L, 1);
  p2 = (HINSTANCE)lua_tohandle(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = (UINT)lua_tonumber(L, 4);
  p5 = lua_tointeger(L, 5);
  p6 = lua_tointeger(L, 6);

  retval = 
    CommandBar_InsertComboBox(
      p1,
      p2,
      p3,
      p4,
      p5,
      p6
    );

  // marshal retval  
  numret += lua_pushWindow(L, retval);

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_InsertMenubar( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  HINSTANCE p2;
  WORD p3;
  WORD p4;

  p1 = lua_toWindow(L, 1);
  p2 = (HINSTANCE)lua_tohandle(L, 2);
  p3 = lua_tointeger(L, 3);
  p4 = lua_tointeger(L, 4);

  retval = 
    CommandBar_InsertMenubar(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_InsertMenubarEx( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  HINSTANCE p2;
  
  WORD p4;

  p1 = lua_toWindow(L, 1);
  p2 = (HINSTANCE)lua_tohandle(L, 2);
  
  p4 = lua_tointeger(L, 4);

  retval = 
    CommandBar_InsertMenubarEx(
      p1,
      p2,
      p3,
      p4
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_DrawMenuBar( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  WORD p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    CommandBar_DrawMenuBar(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_GetMenu( lua_State *L )
{
  int numret = 0;
  HMENU retval;
  HWND p1;
  WORD p2;

  p1 = lua_toWindow(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    CommandBar_GetMenu(
      p1,
      p2
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_AddAdornments( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  DWORD p2;
  DWORD p3;

  p1 = lua_toWindow(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);
  p3 = (DWORD)lua_tonumber(L, 3);

  retval = 
    CommandBar_AddAdornments(
      p1,
      p2,
      p3
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_AlignAdornments( lua_State *L )
{
  int numret = 0;
  void retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    CommandBar_AlignAdornments(
      p1
    );

  // marshal retval  
  

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_CommandBar_Height( lua_State *L )
{
  int numret = 0;
  int retval;
  HWND p1;

  p1 = lua_toWindow(L, 1);

  retval = 
    CommandBar_Height(
      p1
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(USE_COMMANDBAR))
int winapi_IsCommandBarMessage( lua_State *L )
{
  int numret = 0;
  BOOL retval;
  HWND p1;
  MSG* p2;

  p1 = lua_toWindow(L, 1);
  p2 = (MSG*)luacwrap_checktype(L, 2, &regType_MSG.hdr);

  retval = 
    IsCommandBarMessage(
      p1,
      p2
    );

  // marshal retval  
  lua_pushinteger(L, retval); ++numret;

  return numret;
}

#endif
#if (defined(UNDER_CE))
int winapi_ConnMgrEstablishConnection( lua_State *L )
{
  int numret = 0;
  HRESULT retval;
  CONNMGR_CONNECTIONINFO* p1;
  HANDLE p2;

  p1 = (CONNMGR_CONNECTIONINFO*)luacwrap_checktype(L, 1, &regType_CONNMGR_CONNECTIONINFO.hdr);
  p2 = (HANDLE)lua_tohandle(L, 2);

  retval = 
    ConnMgrEstablishConnection(
      p1,
      &p2
    );

  // marshal retval  
  

  return numret;
}

#endif
#if (defined(UNDER_CE))
int winapi_ConnMgrEstablishConnectionSync( lua_State *L )
{
  int numret = 0;
  HRESULT retval;
  CONNMGR_CONNECTIONINFO* p1;
  HANDLE p2;
  DWORD p3;
  DWORD p4;

  p1 = (CONNMGR_CONNECTIONINFO*)luacwrap_checktype(L, 1, &regType_CONNMGR_CONNECTIONINFO.hdr);
  p2 = (HANDLE)lua_tohandle(L, 2);
  p3 = (DWORD)lua_tonumber(L, 3);
  p4 = (DWORD)lua_tonumber(L, 4);

  retval = 
    ConnMgrEstablishConnectionSync(
      p1,
      &p2,
      p3,
      &p4
    );

  // marshal retval  
  

  return numret;
}

#endif
#if (defined(UNDER_CE))
int winapi_ConnMgrConnectionStatus( lua_State *L )
{
  int numret = 0;
  HRESULT retval;
  HANDLE p1;
  DWORD p2;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    ConnMgrConnectionStatus(
      p1,
      &p2
    );

  // marshal retval  
  

  return numret;
}

#endif
#if (defined(UNDER_CE))
int winapi_ConnMgrReleaseConnection( lua_State *L )
{
  int numret = 0;
  HRESULT retval;
  HANDLE p1;
  LONG p2;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = lua_tointeger(L, 2);

  retval = 
    ConnMgrReleaseConnection(
      p1,
      p2
    );

  // marshal retval  
  

  return numret;
}

#endif
#if (defined(UNDER_CE))
int winapi_ConnMgrSetConnectionPriority( lua_State *L )
{
  int numret = 0;
  HRESULT retval;
  HANDLE p1;
  DWORD p2;

  p1 = (HANDLE)lua_tohandle(L, 1);
  p2 = (DWORD)lua_tonumber(L, 2);

  retval = 
    ConnMgrSetConnectionPriority(
      p1,
      p2
    );

  // marshal retval  
  

  return numret;
}

#endif
#if (defined(UNDER_CE))
int winapi_ConnMgrMapURL( lua_State *L )
{
  int numret = 0;
  HRESULT retval;
  LPCWSTR p1;
  GUID* p2;
  DWORD p3;

  p1 = (LPCWSTR)lua_tostring(L, 1);
  p2 = (GUID*)luacwrap_checktype(L, 2, &regType_GUID.hdr);
  p3 = (DWORD)lua_tonumber(L, 3);

  retval = 
    ConnMgrMapURL(
      p1,
      p2,
      &p3
    );

  // marshal retval  
  

  return numret;
}

#endif
#if (defined(UNDER_CE))
int winapi_ConnMgrApiReadyEvent( lua_State *L )
{
  int numret = 0;
  HANDLE retval;


  retval = 
    ConnMgrApiReadyEvent(
    );

  // marshal retval  
  lua_pushlightuserdata(L, (PVOID)retval); ++numret;

  return numret;
}

#endif

static const luaL_reg module_lib[ ] = {
  { "version"           , luawrap_version },
//  { "unittestPrepare"   , luawrap_unittestPrepare },
//  { "unittestPrintStructA"   , luawrap_unittestPrintStructA },

  { "ProcessMessages"   , winapi_ProcessMessages },

  { "GetLastError",  winapi_GetLastError },
  { "SetLastError",  winapi_SetLastError },
  { "GetModuleHandleW",  winapi_GetModuleHandleW },
#if (!defined(UNDER_CE))
  { "OutputDebugStringA",  winapi_OutputDebugStringA },
#endif
  { "OutputDebugStringW",  winapi_OutputDebugStringW },
  { "GetVersionExW",  winapi_GetVersionExW },
  { "CreateProcessW",  winapi_CreateProcessW },
  { "Sleep",  winapi_Sleep },
  { "CreateMutexW",  winapi_CreateMutexW },
  { "CreateEventW",  winapi_CreateEventW },
  { "OpenEventW",  winapi_OpenEventW },
  { "CreateSemaphoreW",  winapi_CreateSemaphoreW },
  { "SetEvent",  winapi_SetEvent },
  { "ResetEvent",  winapi_ResetEvent },
  { "PulseEvent",  winapi_PulseEvent },
  { "ReleaseSemaphore",  winapi_ReleaseSemaphore },
  { "ReleaseMutex",  winapi_ReleaseMutex },
  { "WaitForSingleObject",  winapi_WaitForSingleObject },
  { "GetExitCodeThread",  winapi_GetExitCodeThread },
  { "GetExitCodeProcess",  winapi_GetExitCodeProcess },
  { "RegisterClassW",  winapi_RegisterClassW },
  { "UnregisterClassW",  winapi_UnregisterClassW },
  { "GetClassInfoW",  winapi_GetClassInfoW },
#if (!defined(UNDER_CE))
  { "RegisterClassExW",  winapi_RegisterClassExW },
#endif
#if (!defined(UNDER_CE))
  { "GetClassInfoExW",  winapi_GetClassInfoExW },
#endif
  { "CreateWindowExW",  winapi_CreateWindowExW },
  { "GetDesktopWindow",  winapi_GetDesktopWindow },
  { "IsWindow",  winapi_IsWindow },
  { "IsWindowVisible",  winapi_IsWindowVisible },
  { "IsWindowEnabled",  winapi_IsWindowEnabled },
  { "IsChild",  winapi_IsChild },
  { "DestroyWindow",  winapi_DestroyWindow },
  { "ShowWindow",  winapi_ShowWindow },
  { "EnableWindow",  winapi_EnableWindow },
  { "UpdateWindow",  winapi_UpdateWindow },
  { "RedrawWindow",  winapi_RedrawWindow },
  { "SetParent",  winapi_SetParent },
  { "GetParent",  winapi_GetParent },
  { "FindWindowW",  winapi_FindWindowW },
  { "SetActiveWindow",  winapi_SetActiveWindow },
  { "GetActiveWindow",  winapi_GetActiveWindow },
  { "GetKeyState",  winapi_GetKeyState },
  { "GetAsyncKeyState",  winapi_GetAsyncKeyState },
  { "DrawMenuBar",  winapi_DrawMenuBar },
  { "CreateMenu",  winapi_CreateMenu },
  { "CreatePopupMenu",  winapi_CreatePopupMenu },
  { "DestroyMenu",  winapi_DestroyMenu },
  { "CheckMenuItem",  winapi_CheckMenuItem },
  { "EnableMenuItem",  winapi_EnableMenuItem },
  { "GetSubMenu",  winapi_GetSubMenu },
#if (!defined(UNDER_CE))
  { "GetMenuItemID",  winapi_GetMenuItemID },
#endif
#if (!defined(UNDER_CE))
  { "GetMenuItemCount",  winapi_GetMenuItemCount },
#endif
  { "InsertMenuW",  winapi_InsertMenuW },
  { "AppendMenuW",  winapi_AppendMenuW },
  { "RemoveMenu",  winapi_RemoveMenu },
  { "DeleteMenu",  winapi_DeleteMenu },
  { "TrackPopupMenu",  winapi_TrackPopupMenu },
  { "TrackPopupMenuEx",  winapi_TrackPopupMenuEx },
#if (!defined(UNDER_CE))
  { "InsertMenuItemW",  winapi_InsertMenuItemW },
#endif
  { "GetMenuItemInfoW",  winapi_GetMenuItemInfoW },
  { "SetMenuItemInfoW",  winapi_SetMenuItemInfoW },
#if (!defined(UNDER_CE))
  { "IsMenu",  winapi_IsMenu },
#endif
#if (!defined(UNDER_CE))
  { "CloseWindow",  winapi_CloseWindow },
#endif
#if (!defined(UNDER_CE))
  { "SetMenuItemBitmaps",  winapi_SetMenuItemBitmaps },
#endif
#if (!defined(UNDER_CE))
  { "GetMenuCheckMarkDimensions",  winapi_GetMenuCheckMarkDimensions },
#endif
#if (!defined(UNDER_CE))
  { "ModifyMenuW",  winapi_ModifyMenuW },
#endif
  { "MoveWindow",  winapi_MoveWindow },
  { "SetWindowPos",  winapi_SetWindowPos },
#if (!defined(UNDER_CE))
  { "GetWindowPlacement",  winapi_GetWindowPlacement },
#endif
#if (!defined(UNDER_CE))
  { "SetWindowPlacement",  winapi_SetWindowPlacement },
#endif
  { "BringWindowToTop",  winapi_BringWindowToTop },
  { "GetForegroundWindow",  winapi_GetForegroundWindow },
  { "SetForegroundWindow",  winapi_SetForegroundWindow },
  { "SetFocus",  winapi_SetFocus },
  { "GetFocus",  winapi_GetFocus },
  { "GetMessageW",  winapi_GetMessageW },
  { "PostMessageW",  winapi_PostMessageW },
  { "PostThreadMessageW",  winapi_PostThreadMessageW },
  { "SendMessageW",  winapi_SendMessageW },
  { "PeekMessageW",  winapi_PeekMessageW },
#if (!defined(UNDER_CE))
  { "WaitMessage",  winapi_WaitMessage },
#endif
#if (!defined(UNDER_CE))
  { "WaitForInputIdle",  winapi_WaitForInputIdle },
#endif
  { "TranslateMessage",  winapi_TranslateMessage },
  { "DispatchMessageW",  winapi_DispatchMessageW },
  { "IsDialogMessageW",  winapi_IsDialogMessageW },
  { "CreateAcceleratorTableW",  winapi_CreateAcceleratorTableW },
  { "TranslateAcceleratorW",  winapi_TranslateAcceleratorW },
  { "DefWindowProcW",  winapi_DefWindowProcW },
  { "CallWindowProcW",  winapi_CallWindowProcW },
  { "GetWindowLongW",  winapi_GetWindowLongW },
  { "SetWindowLongW",  winapi_SetWindowLongW },
  { "PostQuitMessage",  winapi_PostQuitMessage },
  { "GetDC",  winapi_GetDC },
  { "GetDCEx",  winapi_GetDCEx },
  { "GetWindowDC",  winapi_GetWindowDC },
  { "ReleaseDC",  winapi_ReleaseDC },
  { "BeginPaint",  winapi_BeginPaint },
  { "EndPaint",  winapi_EndPaint },
  { "InvalidateRect",  winapi_InvalidateRect },
  { "ValidateRect",  winapi_ValidateRect },
  { "GetClientRect",  winapi_GetClientRect },
  { "GetWindowRect",  winapi_GetWindowRect },
  { "ClientToScreen",  winapi_ClientToScreen },
  { "ScreenToClient",  winapi_ScreenToClient },
  { "MapWindowPoints",  winapi_MapWindowPoints },
  { "GetCursorPos",  winapi_GetCursorPos },
  { "GetCapture",  winapi_GetCapture },
  { "SetCapture",  winapi_SetCapture },
  { "ReleaseCapture",  winapi_ReleaseCapture },
#if (!defined(UNDER_CE))
  { "AdjustWindowRect",  winapi_AdjustWindowRect },
#endif
  { "AdjustWindowRectEx",  winapi_AdjustWindowRectEx },
  { "MessageBoxW",  winapi_MessageBoxW },
#if (!defined(UNDER_CE))
  { "MessageBoxExW",  winapi_MessageBoxExW },
#endif
  { "MessageBeep",  winapi_MessageBeep },
#if (!defined(UNDER_CE))
  { "Beep",  winapi_Beep },
#endif
#if (!defined(UNDER_CE))
  { "GetTopWindow",  winapi_GetTopWindow },
#endif
#if (!defined(UNDER_CE))
  { "GetLastActivePopup",  winapi_GetLastActivePopup },
#endif
  { "GetWindow",  winapi_GetWindow },
  { "RegisterHotKey",  winapi_RegisterHotKey },
  { "UnregisterHotKey",  winapi_UnregisterHotKey },
#if (defined(UNDER_CE))
  { "AllKeys",  winapi_AllKeys },
#endif
  { "GetSysColor",  winapi_GetSysColor },
  { "GetSysColorBrush",  winapi_GetSysColorBrush },
  { "DrawFocusRect",  winapi_DrawFocusRect },
  { "DrawEdge",  winapi_DrawEdge },
  { "DrawFrameControl",  winapi_DrawFrameControl },
#if (!defined(UNDER_CE))
  { "DrawCaption",  winapi_DrawCaption },
#endif
#if (!defined(UNDER_CE))
  { "DrawAnimatedRects",  winapi_DrawAnimatedRects },
#endif
  { "DrawTextW",  winapi_DrawTextW },
  { "FillRect",  winapi_FillRect },
#if (!defined(UNDER_CE))
  { "FrameRect",  winapi_FrameRect },
#endif
  { "InvertRect",  winapi_InvertRect },
  { "LoadImageW",  winapi_LoadImageW },
  { "LoadCursorW",  winapi_LoadCursorW },
  { "SetCursor",  winapi_SetCursor },
  { "DeleteObject",  winapi_DeleteObject },
  { "GetObjectW",  winapi_GetObjectW },
  { "GetObjectType",  winapi_GetObjectType },
  { "GetStockObject",  winapi_GetStockObject },
  { "SelectObject",  winapi_SelectObject },
  { "CreateCompatibleDC",  winapi_CreateCompatibleDC },
  { "DeleteDC",  winapi_DeleteDC },
  { "ExcludeClipRect",  winapi_ExcludeClipRect },
  { "IntersectClipRect",  winapi_IntersectClipRect },
  { "GetCurrentObject",  winapi_GetCurrentObject },
#if (!defined(UNDER_CE))
  { "FrameRgn",  winapi_FrameRgn },
#endif
#if (!defined(UNDER_CE))
  { "InvertRgn",  winapi_InvertRgn },
#endif
#if (!defined(UNDER_CE))
  { "PaintRgn",  winapi_PaintRgn },
#endif
  { "SetBkColor",  winapi_SetBkColor },
  { "GetBkColor",  winapi_GetBkColor },
#if (!defined(UNDER_CE))
  { "SetDCBrushColor",  winapi_SetDCBrushColor },
#endif
#if (!defined(UNDER_CE))
  { "GetDCBrushColor",  winapi_GetDCBrushColor },
#endif
#if (!defined(UNDER_CE))
  { "SetDCPenColor",  winapi_SetDCPenColor },
#endif
#if (!defined(UNDER_CE))
  { "GetDCPenColor",  winapi_GetDCPenColor },
#endif
  { "SetBkMode",  winapi_SetBkMode },
  { "GetBkMode",  winapi_GetBkMode },
#if (!defined(UNDER_CE))
  { "SetMapMode",  winapi_SetMapMode },
#endif
#if (!defined(UNDER_CE))
  { "SetPolyFillMode",  winapi_SetPolyFillMode },
#endif
  { "SetTextColor",  winapi_SetTextColor },
  { "SetTextAlign",  winapi_SetTextAlign },
#if (!defined(UNDER_CE))
  { "SetTextJustification",  winapi_SetTextJustification },
#endif
#if (!defined(UNDER_CE))
  { "PtVisible",  winapi_PtVisible },
#endif
  { "RectVisible",  winapi_RectVisible },
#if (!defined(UNDER_CE))
  { "SetViewportExtEx",  winapi_SetViewportExtEx },
#endif
#if (!defined(UNDER_CE))
  { "SetViewportOrgEx",  winapi_SetViewportOrgEx },
#endif
#if (!defined(UNDER_CE))
  { "SetWindowExtEx",  winapi_SetWindowExtEx },
#endif
#if (!defined(UNDER_CE))
  { "SetWindowOrgEx",  winapi_SetWindowOrgEx },
#endif
#if (!defined(UNDER_CE))
  { "OffsetViewportOrgEx",  winapi_OffsetViewportOrgEx },
#endif
#if (!defined(UNDER_CE))
  { "OffsetWindowOrgEx",  winapi_OffsetWindowOrgEx },
#endif
#if (!defined(UNDER_CE))
  { "ScaleViewportExtEx",  winapi_ScaleViewportExtEx },
#endif
#if (!defined(UNDER_CE))
  { "ScaleWindowExtEx",  winapi_ScaleWindowExtEx },
#endif
  { "CreatePen",  winapi_CreatePen },
  { "CreatePenIndirect",  winapi_CreatePenIndirect },
  { "CreatePatternBrush",  winapi_CreatePatternBrush },
  { "CreateSolidBrush",  winapi_CreateSolidBrush },
#if (!defined(UNDER_CE))
  { "CreateHatchBrush",  winapi_CreateHatchBrush },
#endif
  { "CreateFontIndirectW",  winapi_CreateFontIndirectW },
#if (!defined(UNDER_CE))
  { "CreateFontW",  winapi_CreateFontW },
#endif
  { "GetTextExtentExPointW",  winapi_GetTextExtentExPointW },
  { "GetTextExtentPoint32W",  winapi_GetTextExtentPoint32W },
  { "CreateRectRgn",  winapi_CreateRectRgn },
  { "CreateRectRgnIndirect",  winapi_CreateRectRgnIndirect },
#if (!defined(UNDER_CE))
  { "CreateRoundRectRgn",  winapi_CreateRoundRectRgn },
#endif
#if (!defined(UNDER_CE))
  { "CreateEllipticRgn",  winapi_CreateEllipticRgn },
#endif
#if (!defined(UNDER_CE))
  { "CreateEllipticRgnIndirect",  winapi_CreateEllipticRgnIndirect },
#endif
  { "EqualRgn",  winapi_EqualRgn },
  { "CombineRgn",  winapi_CombineRgn },
  { "OffsetRgn",  winapi_OffsetRgn },
  { "SetRectRgn",  winapi_SetRectRgn },
  { "PtInRegion",  winapi_PtInRegion },
  { "RectInRegion",  winapi_RectInRegion },
#if (!defined(UNDER_CE))
  { "BeginPath",  winapi_BeginPath },
#endif
#if (!defined(UNDER_CE))
  { "CloseFigure",  winapi_CloseFigure },
#endif
#if (!defined(UNDER_CE))
  { "EndPath",  winapi_EndPath },
#endif
#if (!defined(UNDER_CE))
  { "FillPath",  winapi_FillPath },
#endif
#if (!defined(UNDER_CE))
  { "FlattenPath",  winapi_FlattenPath },
#endif
#if (!defined(UNDER_CE))
  { "PathToRegion",  winapi_PathToRegion },
#endif
#if (!defined(UNDER_CE))
  { "StrokeAndFillPath",  winapi_StrokeAndFillPath },
#endif
#if (!defined(UNDER_CE))
  { "StrokePath",  winapi_StrokePath },
#endif
#if (!defined(UNDER_CE))
  { "WidenPath",  winapi_WidenPath },
#endif
#if (!defined(UNDER_CE))
  { "Arc",  winapi_Arc },
#endif
#if (!defined(UNDER_CE))
  { "ArcTo",  winapi_ArcTo },
#endif
#if (!defined(UNDER_CE))
  { "Chord",  winapi_Chord },
#endif
  { "LineTo",  winapi_LineTo },
  { "MoveToEx",  winapi_MoveToEx },
  { "Ellipse",  winapi_Ellipse },
#if (!defined(UNDER_CE))
  { "Pie",  winapi_Pie },
#endif
  { "Rectangle",  winapi_Rectangle },
  { "RoundRect",  winapi_RoundRect },
#if (!defined(UNDER_CE))
  { "ExtFloodFill",  winapi_ExtFloodFill },
#endif
  { "FillRgn",  winapi_FillRgn },
#if (!defined(UNDER_CE))
  { "FloodFill",  winapi_FloodFill },
#endif
  { "BitBlt",  winapi_BitBlt },
  { "PatBlt",  winapi_PatBlt },
  { "StretchBlt",  winapi_StretchBlt },
#if (!defined(UNDER_CE))
  { "TransparentBlt",  winapi_TransparentBlt },
#endif
#if (!defined(UNDER_CE))
  { "TextOutW",  winapi_TextOutW },
#endif
  { "ExtTextOutW",  winapi_ExtTextOutW },
#if (defined(USE_OPENGL))
  { "wglCopyContext",  winapi_wglCopyContext },
#endif
#if (defined(USE_OPENGL))
  { "wglCreateContext",  winapi_wglCreateContext },
#endif
#if (defined(USE_OPENGL))
  { "wglCreateLayerContext",  winapi_wglCreateLayerContext },
#endif
#if (defined(USE_OPENGL))
  { "wglDeleteContext",  winapi_wglDeleteContext },
#endif
#if (defined(USE_OPENGL))
  { "wglGetCurrentContext",  winapi_wglGetCurrentContext },
#endif
#if (defined(USE_OPENGL))
  { "wglGetCurrentDC",  winapi_wglGetCurrentDC },
#endif
#if (defined(USE_OPENGL))
  { "wglMakeCurrent",  winapi_wglMakeCurrent },
#endif
#if (defined(USE_OPENGL))
  { "wglShareLists",  winapi_wglShareLists },
#endif
#if (defined(USE_OPENGL))
  { "wglUseFontBitmapsA",  winapi_wglUseFontBitmapsA },
#endif
#if (defined(USE_OPENGL))
  { "wglUseFontBitmapsW",  winapi_wglUseFontBitmapsW },
#endif
#if (defined(USE_OPENGL))
  { "SwapBuffers",  winapi_SwapBuffers },
#endif
#if (defined(USE_OPENGL))
  { "wglRealizeLayerPalette",  winapi_wglRealizeLayerPalette },
#endif
#if (defined(USE_OPENGL))
  { "wglSwapLayerBuffers",  winapi_wglSwapLayerBuffers },
#endif
  { "InitCommonControls",  winapi_InitCommonControls },
#if (!defined(UNDER_CE))
  { "ImageList_LoadImageW",  winapi_ImageList_LoadImageW },
#endif
  { "ImageList_AddMasked",  winapi_ImageList_AddMasked },
  { "GetOpenFileNameW",  winapi_GetOpenFileNameW },
  { "GetSaveFileNameW",  winapi_GetSaveFileNameW },
  { "ChooseColor",  winapi_ChooseColor },
  { "CommDlgExtendedError",  winapi_CommDlgExtendedError },
#if (!defined(UNDER_CE))
  { "PrintDlgW",  winapi_PrintDlgW },
#endif
  { "DrawXorBar",  winapi_DrawXorBar },
#if (defined(UNDER_CE))
  { "RequestPowerNotifications",  winapi_RequestPowerNotifications },
#endif
#if (defined(UNDER_CE))
  { "StopPowerNotifications",  winapi_StopPowerNotifications },
#endif
#if (defined(USE_MSGQUEUE))
  { "CreateMsgQueue",  winapi_CreateMsgQueue },
#endif
#if (defined(USE_MSGQUEUE))
  { "OpenMsgQueue",  winapi_OpenMsgQueue },
#endif
#if (defined(USE_MSGQUEUE))
  { "ReadMsgQueue",  winapi_ReadMsgQueue },
#endif
#if (defined(USE_MSGQUEUE))
  { "WriteMsgQueue",  winapi_WriteMsgQueue },
#endif
#if (defined(USE_MSGQUEUE))
  { "GetMsgQueueInfo",  winapi_GetMsgQueueInfo },
#endif
#if (defined(USE_MSGQUEUE))
  { "CloseMsgQueue",  winapi_CloseMsgQueue },
#endif
#if (defined(USE_AYGSHELL))
  { "SHInitExtraControls",  winapi_SHInitExtraControls },
#endif
#if (defined(USE_AYGSHELL))
  { "SHInitDialog",  winapi_SHInitDialog },
#endif
#if (defined(USE_AYGSHELL))
  { "SHCreateMenuBar",  winapi_SHCreateMenuBar },
#endif
#if (defined(USE_AYGSHELL))
  { "SHFindMenuBar",  winapi_SHFindMenuBar },
#endif
#if (defined(USE_AYGSHELL))
  { "SHHandleWMActivate",  winapi_SHHandleWMActivate },
#endif
#if (defined(USE_AYGSHELL))
  { "SHHandleWMSettingChange",  winapi_SHHandleWMSettingChange },
#endif
#if (defined(USE_AYGSHELL))
  { "SHFullScreen",  winapi_SHFullScreen },
#endif
#if (defined(USE_AYGSHELL))
  { "SHDoneButton",  winapi_SHDoneButton },
#endif
#if (defined(USE_AYGSHELL))
  { "SHSetAppKeyWndAssoc",  winapi_SHSetAppKeyWndAssoc },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_Create",  winapi_CommandBar_Create },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_Show",  winapi_CommandBar_Show },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_AddBitmap",  winapi_CommandBar_AddBitmap },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_InsertComboBox",  winapi_CommandBar_InsertComboBox },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_InsertMenubar",  winapi_CommandBar_InsertMenubar },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_InsertMenubarEx",  winapi_CommandBar_InsertMenubarEx },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_DrawMenuBar",  winapi_CommandBar_DrawMenuBar },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_GetMenu",  winapi_CommandBar_GetMenu },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_AddAdornments",  winapi_CommandBar_AddAdornments },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_AlignAdornments",  winapi_CommandBar_AlignAdornments },
#endif
#if (defined(USE_COMMANDBAR))
  { "CommandBar_Height",  winapi_CommandBar_Height },
#endif
#if (defined(USE_COMMANDBAR))
  { "IsCommandBarMessage",  winapi_IsCommandBarMessage },
#endif
#if (defined(UNDER_CE))
  { "ConnMgrEstablishConnection",  winapi_ConnMgrEstablishConnection },
#endif
#if (defined(UNDER_CE))
  { "ConnMgrEstablishConnectionSync",  winapi_ConnMgrEstablishConnectionSync },
#endif
#if (defined(UNDER_CE))
  { "ConnMgrConnectionStatus",  winapi_ConnMgrConnectionStatus },
#endif
#if (defined(UNDER_CE))
  { "ConnMgrReleaseConnection",  winapi_ConnMgrReleaseConnection },
#endif
#if (defined(UNDER_CE))
  { "ConnMgrSetConnectionPriority",  winapi_ConnMgrSetConnectionPriority },
#endif
#if (defined(UNDER_CE))
  { "ConnMgrMapURL",  winapi_ConnMgrMapURL },
#endif
#if (defined(UNDER_CE))
  { "ConnMgrApiReadyEvent",  winapi_ConnMgrApiReadyEvent },
#endif
  
  { NULL, NULL }
};

//////////////////////////////////////////////////////////////////////////
/**

  registers structures as Lua types

  @param[in]  L  pointer lua state

*/////////////////////////////////////////////////////////////////////////
int register_winapi(lua_State *L)
{
  // index of module table
  int M = lua_gettop(L);

  // register package functions
  luaL_register( L, NULL, module_lib );

  // register array types
  luacwrap_registertype(L, M, &regType_UINT8_32.hdr);
  luacwrap_registertype(L, M, &regType_UINT16_128.hdr);
  luacwrap_registertype(L, M, &regType_UINT16_32.hdr);
  luacwrap_registertype(L, M, &regType_UINT8_8.hdr);
  
  // register structure types
  luacwrap_registertype(L, M, &regType_GUID.hdr);
#if (defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_MSGQUEUEINFO.hdr);
#endif
  luacwrap_registertype(L, M, &regType_TVITEMW.hdr);
#if (!defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_LVGROUPMETRICS.hdr);
#endif
  luacwrap_registertype(L, M, &regType_PROCESS_INFORMATION.hdr);
  luacwrap_registertype(L, M, &regType_LVCOLUMNW.hdr);
#if (defined(USE_AYGSHELL))
  luacwrap_registertype(L, M, &regType_SHINITDLGINFO.hdr);
#endif
  luacwrap_registertype(L, M, &regType_LOGPEN.hdr);
  luacwrap_registertype(L, M, &regType_SECURITY_ATTRIBUTES.hdr);
  luacwrap_registertype(L, M, &regType_LOGFONTW.hdr);
#if (defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_POWER_BROADCAST.hdr);
#endif
#if (!defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_NMTCKEYDOWN.hdr);
#endif
  luacwrap_registertype(L, M, &regType_STARTUPINFOW.hdr);
  luacwrap_registertype(L, M, &regType_POINTS.hdr);
  luacwrap_registertype(L, M, &regType_RECT.hdr);
#if (defined(USE_AYGSHELL))
  luacwrap_registertype(L, M, &regType_SHMENUBARINFO.hdr);
#endif
  luacwrap_registertype(L, M, &regType_OSVERSIONINFOW.hdr);
  luacwrap_registertype(L, M, &regType_OPENFILENAMEW.hdr);
  luacwrap_registertype(L, M, &regType_TCITEMHEADERW.hdr);
  luacwrap_registertype(L, M, &regType_MENUITEMINFOW.hdr);
  luacwrap_registertype(L, M, &regType_CHOOSECOLOR.hdr);
#if (defined(USE_COMMANDBAR))
  luacwrap_registertype(L, M, &regType_COMMANDBANDSRESTOREINFO.hdr);
#endif
#if (defined(USE_AYGSHELL))
  luacwrap_registertype(L, M, &regType_SHACTIVATEINFO.hdr);
#endif
#if (defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_MSGQUEUEOPTIONS.hdr);
#endif
  luacwrap_registertype(L, M, &regType_NMHDR.hdr);
#if (!defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_PRINTDLGW.hdr);
#endif
  luacwrap_registertype(L, M, &regType_TCHITTESTINFO.hdr);
#if (!defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_NMITEMACTIVATE.hdr);
#endif
  luacwrap_registertype(L, M, &regType_COPYDATASTRUCT.hdr);
  luacwrap_registertype(L, M, &regType_TBBUTTONINFOW.hdr);
#if (!defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_WNDCLASSEXW.hdr);
#endif
  luacwrap_registertype(L, M, &regType_ACCEL.hdr);
#if (defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_CONNMGR_CONNECTIONINFO.hdr);
#endif
  luacwrap_registertype(L, M, &regType_POINT.hdr);
  luacwrap_registertype(L, M, &regType_CREATESTRUCTW.hdr);
  luacwrap_registertype(L, M, &regType_TVINSERTSTRUCTW.hdr);
  luacwrap_registertype(L, M, &regType_DLGTEMPLATE.hdr);
  luacwrap_registertype(L, M, &regType_PAINTSTRUCT.hdr);
  luacwrap_registertype(L, M, &regType_TPMPARAMS.hdr);
  luacwrap_registertype(L, M, &regType_SIZE.hdr);
#if (!defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_LVGROUP.hdr);
#endif
  luacwrap_registertype(L, M, &regType_NMLVKEYDOWN.hdr);
  luacwrap_registertype(L, M, &regType_NMLISTVIEW.hdr);
  luacwrap_registertype(L, M, &regType_DLGITEMTEMPLATE.hdr);
  luacwrap_registertype(L, M, &regType_NMTREEVIEWW.hdr);
#if (!defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_WINDOWPLACEMENT.hdr);
#endif
  luacwrap_registertype(L, M, &regType_NMLVDISPINFOW.hdr);
  luacwrap_registertype(L, M, &regType_MSG.hdr);
  luacwrap_registertype(L, M, &regType_TCITEMW.hdr);
  luacwrap_registertype(L, M, &regType_LVITEMW.hdr);
  luacwrap_registertype(L, M, &regType_WNDCLASSW.hdr);
#if (!defined(UNDER_CE))
  luacwrap_registertype(L, M, &regType_OSVERSIONINFOEXW.hdr);
#endif

  winapi_RegisterWndProc(L);

  registerAbstractions(L);
  
  return 1;
}


